

#include "StdAfx.h"

#include <locale.h>
//#include <windows.h>


#include <stdio.h>


#include "CSvcMan.h"
/* CuN */

void WINAPI serviceProc(DWORD argc, LPTSTR *argv);
void WINAPI serviceCtl(DWORD ctl);


extern CSvcMan			*pSvcManager;





CSvcMan::CSvcMan()
{
	m_szpServiceGroup_Title = NULL;
	m_szpService_Name = NULL;
	m_szpService_Description = NULL;

	m_fpLog = NULL;



	char *locale = setlocale(LC_ALL,  "japanese_japan" );

	return;
}

CSvcMan::~CSvcMan()
{
	if (m_szpServiceGroup_Title) {
		delete [] m_szpServiceGroup_Title;
		m_szpServiceGroup_Title = NULL;
	}
	if (m_szpService_Name) {
		delete [] m_szpService_Name;
		m_szpService_Name = NULL;
	}
	if (m_szpService_Description) {
		delete [] m_szpService_Description;
		m_szpService_Description = NULL;
	}


	if (m_fpLog) {
		fclose(m_fpLog);
		m_fpLog = NULL;
	}

	return;
}



BOOL CSvcMan::Resister( void )
{
	if ( RegisterServiceMe( FALSE ) )
		return FALSE;

	return TRUE;
}

void CSvcMan::UnResister( void )
{
	RegisterServiceMe( TRUE );
}




BOOL CSvcMan::SetServiceName( TCHAR *tszGroupName, TCHAR *tszServiceName
							 , TCHAR *tszServiceDescription )
{
	
	if (m_szpServiceGroup_Title) {
		delete [] m_szpServiceGroup_Title;
		m_szpServiceGroup_Title = NULL;
	}

	if (m_szpService_Name) {
		delete [] m_szpService_Name;
		m_szpService_Name = NULL;
	}

	if (m_szpService_Description) {
		delete [] m_szpService_Description;
		m_szpService_Description = NULL;
	}

	
	if ( tszGroupName != NULL ) {
		m_szpServiceGroup_Title = new TCHAR[ wcslen( tszGroupName) +1  ];
		if ( m_szpServiceGroup_Title==NULL )
			return FALSE;
		wcscpy_s( m_szpServiceGroup_Title, wcslen(tszGroupName) + 1 ,  tszGroupName );
	}

	if ( tszServiceName != NULL ) {
		m_szpService_Name = new TCHAR[ wcslen( tszServiceName) + 1 ];
		if ( m_szpService_Name==NULL ) {
			m_szpService_Name = NULL;
			return FALSE;
		}
		wcscpy_s( m_szpService_Name, wcslen(tszServiceName) + 1, tszServiceName );
	}

	if ( tszServiceDescription != NULL ) {
		m_szpService_Description = new TCHAR[ wcslen( tszServiceDescription) + 1 ];
		if ( m_szpService_Description==NULL ) {
			m_szpService_Description = NULL;
			return FALSE;
		}
		wcscpy_s( m_szpService_Description, wcslen(tszServiceDescription) + 1, tszServiceDescription );
	}


	return TRUE;
}





int CSvcMan::ExecuteControl() {

	/*** Rg[1bԎ󂯕tB***/
	if(WaitForSingleObject( pSvcManager->hServEvnt, 1000)==WAIT_TIMEOUT ){
		return 1;
	}

	if( pSvcManager->gServStus == SERVICE_STOPPED){
		ResetEvent( pSvcManager->hServEvnt );
		return 2;
	}

	return 0;

}





void CSvcMan::ServiceMain( void )
{


	SERVICE_TABLE_ENTRY arr_serv[] = {
		{ m_szpService_Name, serviceProc },  // T[rX, T[rX̊֐
		{ NULL, NULL }                 // T[rXP̏ꍇ NULL e[uKv
	};

	if(!StartServiceCtrlDispatcher(arr_serv)){
		// MessageBoxȂ񂩎g, OIĂȂƂɑΏłȂB
		pSvcManager->Log( L"Ȃ񂩃G[NႢ܂B\n" );
	}


}


void CSvcMan::ServiceFirstIn( void )
{



 /*** Rg[̓o^? ***/
  hServStus = RegisterServiceCtrlHandler(
      m_szpService_Name, serviceCtl);
  if(pSvcManager->hServStus==NULL){
    Log( L"T[rXJnł܂łB\n" );
    return;
  }



  /*** T[rX̃Rg[󂯎鏀 ***/
  hServEvnt = CreateEvent(NULL, false, false, NULL);

  /*** sł邱Ƃm点B
   * Ȃ, Jn1bȓɂ܂łȂƂ߂Ȃ悤B
   */
  sendServiceStatus(SERVICE_RUNNING);



	/* I[o[Chꂽ Execute Ăяo */
	this->Execute();





  CloseHandle( pSvcManager->hServEvnt );




  /*** IƂm点B***/
  sendServiceStatus(SERVICE_STOPPED);



}









int CSvcMan::RegisterServiceMe( BOOL blDelete ) {


	SC_HANDLE 		hServiceControlManager;
	SC_HANDLE		hSvcHandle;

	if ( !m_szpServiceGroup_Title || !m_szpService_Name) {
		Log( L"vOG[FT[rXo^Ă܂B\n" );
		return -1;
	}



	/* http://jim-tamura.at.webry.info/200607/article_3.html   */
	/*   */

	hServiceControlManager = OpenSCManager(
		NULL, SERVICES_ACTIVE_DATABASE, SC_MANAGER_ALL_ACCESS);

	if ( hServiceControlManager == NULL ) {
		return -2;
	}


	/* T[rXo^ς݂mF */
	hSvcHandle = OpenService(
					hServiceControlManager, 
					m_szpService_Name, 
					DELETE );
	if ( hSvcHandle == NULL ) {
		/* T[rX݂͑Ȃ */
		if ( blDelete ) {
			Log( L"o^Ă܂B\n" );
			CloseServiceHandle(hServiceControlManager);
			return 0;
		}
	} else {

		/* pXĂ邩mȂ̂łƂɂ
		   xT[rX폜 */
		if(!DeleteService(hSvcHandle)){

			/* T[rX폜G[ */
			switch (GetLastError() )
			{
			case ERROR_ACCESS_DENIED:
				Log( L"T[rX폜G[FANZX\n" );
				break;
			case ERROR_INVALID_HANDLE:
				Log( L"T[rX폜G[Fnh\n" );
				break;
			case ERROR_SERVICE_MARKED_FOR_DELETE:
				Log( L"T[rX폜G[F폜̂߂Ƀ}[NĂ\n" );
				break;
			}

			

			/* T[rX폜G[ */
			if ( blDelete ) {
				CloseServiceHandle(hSvcHandle);
				CloseServiceHandle(hServiceControlManager);
				Log( L"T[rX폜ł܂łB\n" );
				return -3;
			}
		}
		CloseServiceHandle(hSvcHandle);

		if ( blDelete ) {
			CloseServiceHandle(hServiceControlManager);
			Log( L"T[rX폜܂B\n" );
			return 0;
		}

	}




	/******* g̃pX擾 ******************/
	TCHAR			tszFileName[ MAX_PATH ];
	DWORD			dwRet;
	HMODULE hModule = GetModuleHandle( NULL );
	if ( hModule == NULL ) {
		CloseServiceHandle(hServiceControlManager);
		return -4;
	}

	dwRet = GetModuleFileName( hModule, tszFileName, sizeof( tszFileName ) );
	if ( dwRet == 0 ) {
		CloseServiceHandle(hServiceControlManager);
		CloseHandle( hModule );
		return -5;
	}
	

	TCHAR			tszRunArgs[ MAX_PATH*2 ];

	wcscpy_s( tszRunArgs, _countof( tszRunArgs ), L"\""             );
	wcscat_s( tszRunArgs, _countof( tszRunArgs ), tszFileName       );
	wcscat_s( tszRunArgs, _countof( tszRunArgs ), L"\" -svccall"    );





	/* T[rXVK쐬Ao^ */
	hSvcHandle = CreateService(hServiceControlManager,
		m_szpService_Name,				/* T[rX */
		m_szpServiceGroup_Title,		/* T[rXO[v */
		SERVICE_ALL_ACCESS,
		SERVICE_WIN32_OWN_PROCESS,
		SERVICE_AUTO_START,
		SERVICE_ERROR_NORMAL,
		tszRunArgs,						/*T[rXvO̎st@C̃tpX*/
		NULL,	
		NULL,
		NULL,
		NULL,
		NULL);

	if ( hSvcHandle == NULL ) {
		CloseServiceHandle(hServiceControlManager);
		Log( L"T[rX̓o^Ɏs܂B\n" );
		return -6;
	}


	/* fXNgbvƂ̑Θb\ */
	/*  (VXegCɃACR֌Wɂ) */
	BOOL blRet = ChangeServiceConfig( 
			hSvcHandle,						/* SC_HANDLE hService */
			SERVICE_WIN32_OWN_PROCESS | 
			SERVICE_INTERACTIVE_PROCESS,	/* DWORD dwServiceType */
 			SERVICE_NO_CHANGE,				/* DWORD dwStartType */
			SERVICE_NO_CHANGE,				/* DWORD dwErrorControl */
			NULL,							/* LPCTSTR lpBinaryPathName */
			NULL,							/* LPCTSTR lpLoadOrderGroup */
			NULL,							/* LPDWORD lpdwTagId */
			NULL,							/* LPCTSTR lpDependencies */

			NULL,							/* LPCTSTR lpServiceStartName */
			NULL,							/* LPCTSTR lpPassword */
			NULL							/* LPCTSTR lpDisplayName */
			);
	if ( !blRet ) {
		CloseServiceHandle(hServiceControlManager);
		Log( L"T[rXo^̐ݒύXɎs܂B\n" );
		return -7;
	}





	SERVICE_DESCRIPTION		service_description;

	if ( m_szpService_Description == NULL ) {
		service_description.lpDescription = L"";
	} else {
		service_description.lpDescription = m_szpService_Description;
	}

	blRet = ChangeServiceConfig2( hSvcHandle,
									SERVICE_CONFIG_DESCRIPTION,
									&service_description );
	if ( !blRet ) {
		CloseServiceHandle(hServiceControlManager);
		Log( L"T[rXo^̐ݒύXɎs܂(2)B\n" );
		return -8;
	}






	/* G[ċN */

	SERVICE_FAILURE_ACTIONS				service_failure_actions;
	service_failure_actions.dwResetPeriod    = 1800;
	service_failure_actions.lpRebootMsg      = NULL;
	service_failure_actions.cActions         = 3;

	SC_ACTION		sc_action[ 3 ];
	sc_action[ 0 ].Type  = SC_ACTION_RESTART;
	sc_action[ 0 ].Delay = 3000;
	sc_action[ 1 ].Type  = SC_ACTION_RESTART;
	sc_action[ 1 ].Delay = 3000;
	sc_action[ 2 ].Type  = SC_ACTION_RESTART;
	sc_action[ 2 ].Delay = 3000;

	service_failure_actions.lpsaActions     = sc_action;

	blRet = ChangeServiceConfig2( hSvcHandle,
									SERVICE_CONFIG_FAILURE_ACTIONS,
									&service_failure_actions );
	if ( !blRet ) {
		CloseServiceHandle(hServiceControlManager);
		Log( L"T[rXo^̐ݒύXɎs܂(3)B\n" );
		return -9;
	}



	Log( L"T[rXo^܂B\n" );

	
	CloseServiceHandle(hServiceControlManager);
	CloseServiceHandle( hSvcHandle );
	return 0;

}








int CSvcMan::sendServiceStatus(DWORD serviceStatus){
  SERVICE_STATUS servStus = {
    SERVICE_WIN32_OWN_PROCESS,
    serviceStatus,             // sĂ܂B
    SERVICE_ACCEPT_STOP,       // Îݎ󂯕t܂B
    0,0,0,0};
  SetServiceStatus(
			pSvcManager->hServStus, 
			&servStus );

  return 0;

}













/*** T[rX̃C ***/
void WINAPI serviceProc(DWORD , LPTSTR*){

	pSvcManager->ServiceFirstIn();

}




/*** T[rX̃Rg[ 
 * , SCMɂ, Ă΂񂾂낤ȂB
 ***/
void WINAPI serviceCtl(DWORD ctl){
  switch(ctl){
  case SERVICE_CONTROL_STOP:
    pSvcManager->gServStus = SERVICE_STOPPED;
    SetEvent( pSvcManager->hServEvnt );
    break;
  }
  return;
}


