#include "stdafx.h"

#include "MailManage.h"
#include "MailSMTP.h"

#include "..\etc\IoIni.h"
#include "MailEnc.h"
#include "..\etc\SyslogD.h"
#include "..\etc\logPlus.h"

#include "..\etc\Nv3GetIp.h"
#include "..\etc\GetIPBrs\GetIPBrs.h"

#include "..\MiniHttp\MHttpTray.h"


using namespace nsSvcMHttp;


bool nsSvcMHttp::MailReactor::CheckSvrMail( void ) 
{


	if ( m_Thread_MailPolling != nullptr ) {
		if ( m_Thread_MailPolling->IsAlive ) {
			return false;
		}
		delete m_Thread_MailPolling;
	}

	m_Thread_MailPolling = gcnew Thread( gcnew ThreadStart( 
		this, &nsSvcMHttp::MailReactor::PoleMailSvrThreadMain )  );

	m_Thread_MailPolling->Start();
	return true;
}


void nsSvcMHttp::MailReactor::PoleMailSvrThreadMain( void )
{
	bool blRet;


#ifndef _DEBUG
	try {
#endif

		blRet = ChkPollMSvr();

#ifndef _DEBUG
	} catch ( Exception ^e ) {

		/************************************************************************/
		/**** ZbVm Socket->Recieve/Send ̃^CG[΍ ****/
		/************************************************************************/
		/* M̏ꏊSĂɃG[gbv𒣂̂ł͂B */
		/* {IȃR[hύXKvȏԂł͖H */
		blRet = false;

		Console::WriteLine( "MailReactor::PoleMailSvrThreadMain : ChkPollMSvr() Ń^CG[" );
		m_pLogP->LogOFWithDate( 0,
			"MailReactor::PoleMailSvrThreadMain : ChkPollMSvr() Ń^CG[" + 
			e->StackTrace + " : " + e->Message );

		delete e;
	}
#endif

	if ( blRet == false ) {
		Console::WriteLine( 
			"MailReactor::PoleMailSvrThreadMain : ChkPollMSvr()  false Ԃ܂" );
		m_pLogP->LogOFWithDate( 0, 
			"MailReactor::PoleMailSvrThreadMain : ChkPollMSvr()  false Ԃ܂" );
	}



}




bool nsSvcMHttp::MailReactor::CheckOrderMailExist( MailDataCage ^pMailData )
{
	bool	blFind = false;
	int			intRet = -1;
	
	
	IniInfo		^pIniInfo = gcnew IniInfo();
	String		^strCMD_GetUrl = gcnew String( "URLcome" );

	bool blRetIni = 
		pIniInfo->ReadIni( IniInfo::KeyTable::STR_MAILCMD_MAILREACT_GETURL_SUBJECT, 
						strCMD_GetUrl );
	if ( !blRetIni ) {
		delete strCMD_GetUrl;
		return blFind;
	}

	String		^strPollTime = gcnew String( "300" );
	Int32	int32PollTime;
	blRetIni = 
		pIniInfo->ReadIni( IniInfo::KeyTable::STR_MAILMANAGE_PO3POLLINGTIME_SEC, 
						strPollTime );

	try {
		int32PollTime = System::Convert::ToInt32( strPollTime );
	} catch ( Exception ^e ) {
		delete e;
		int32PollTime = 300;
	}

	delete strPollTime;
	delete pIniInfo;





	/* w̃[Ă邩mF */

	String		^strSubject	= pMailData->m_strSubject;


	/* Ȃ \d ŏIf[^ɂȂĂEEE */
	if ( String::Concat( strCMD_GetUrl , "\r"   ) != strSubject 
	    	&&
		 String::Concat( strCMD_GetUrl , "\r\n" ) != strSubject 
	    	&&
		 String::Concat( strCMD_GetUrl , "\n"   ) != strSubject
	    ) {
		;
	} else {
		blFind = true;
	}



	delete strCMD_GetUrl;
	return blFind;

}









bool nsSvcMHttp::MailReactor::SendIpAddrInf( array<MailDataCage^> ^pMailDatas, System::Collections::ArrayList ^arIndexList )
{
	String		^strTrayMsg = gcnew String( "" );

	MailSend		^pMailSend = gcnew MailSend();
	
	

	Socket ^s = pMailSend->CreateMailSendSocket();
	if ( s == nullptr )
		return false;
	pMailSend->m_s = s;


	pMailSend->m_strarRcptTo
		= gcnew array<String^>( arIndexList->Count );

	for ( int nCnt=0; nCnt < arIndexList->Count; nCnt++ ) {

		int nMailNo = static_cast<int>( arIndexList[ nCnt ] );

		pMailSend->m_strarRcptTo[ nCnt ] = 
			pMailDatas[ nMailNo ]->m_strSender;

		if ( strTrayMsg != "" ) {
			strTrayMsg += ", ";
		}
		strTrayMsg += pMailSend->m_strarRcptTo[ nCnt ];

	}

	pMailSend->m_strSubject = gcnew String( "http URL" );



	String		^strUrl = GetSvrIp();


	Int32		^int32ServerPort = nullptr;
	IniInfo		^pIniInfo = gcnew IniInfo();
	bool blRet = pIniInfo->ReadIni( IniInfo::KeyTable::STR_HTTPFILE_PORT , int32ServerPort );
	delete pIniInfo;
	if ( !blRet ) {
		int32ServerPort = 8080;
	}

	String		^strPort = int32ServerPort->ToString();
	pMailSend->m_strData    = String::Concat( "http://", strUrl, ":", strPort, "/" );
	delete strPort;
	delete int32ServerPort;



	MHttpTray	^pMHttpTray	= gcnew MHttpTray();

	String ^strTraySend = "tqkʒm[𑗐M܂F" + strTrayMsg;
	pMHttpTray->AddMessage( strTraySend );
	delete strTraySend;
	delete pMHttpTray;

	blRet = pMailSend->SendMail();



	delete strTrayMsg;

	delete pMailSend;


	return blRet;

}




String^ nsSvcMHttp::MailReactor::GetSvrIp( void )
{
	String ^strRet = nullptr;

	IniInfo	^pIniInfo        = gcnew IniInfo();
	String  ^strNv3Enable    = gcnew String( "false" );
	String  ^strNv3EnableSml = nullptr;
	bool blUseNv3Modem       = false;

	pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_NV3MODEM_USEPOLLING , 
		strNv3Enable );
	strNv3EnableSml = strNv3Enable->ToLower();

	if ( strNv3EnableSml == "true" ) {
		blUseNv3Modem = true;
	}
	delete strNv3Enable;
	delete strNv3EnableSml;





	String  ^strPrs300Enable    = gcnew String( "false" );
	bool	blUsePrs300Modem    = false;
	pIniInfo->ReadIni( 
		IniInfo::KeyTable::STR_PRS300MODEM_USEPOLLING , 
		strPrs300Enable );
	strPrs300Enable = strPrs300Enable->ToLower();
	if ( strPrs300Enable == "true" ) {
		blUsePrs300Modem = true;
	}
	delete strPrs300Enable;






	if ( blUsePrs300Modem == true ) {

		/* Ăяo̎ */
		/* GUI      exe _uNbNŋN */
		/* CUI      ÑVXegCo^A */
		/*          mail */
		if ( nsSvcMHttp::IPGetBrowse::IpGot() ) {
			strRet = nsSvcMHttp::IPGetBrowse::m_strIpStr;
		} else {
			/* GUI \͎dȂH */
			/* q}Ȏɂł΍l悤BBB */
			strRet = "PRS300IPGetError";
			pIniInfo->ReadIni(
			IniInfo::KeyTable::STR_SYSLOGD_FIRSTPPPIP, 
					strRet );
		
		}



	} else if ( blUseNv3Modem == true ) {
		String ^strModemIp = gcnew String( "0.0.0.0" );
		String ^strUsrName = gcnew String( "user" );
		String ^strPass    = gcnew String( "" );

		pIniInfo->ReadIni( 
			IniInfo::KeyTable::STR_NV3MODEM_IPADDRESS, 
			strModemIp );
		pIniInfo->ReadIni( 
			IniInfo::KeyTable::STR_NV3MODEM_USERNAME, 
			strUsrName );
		pIniInfo->ReadIni( 
			IniInfo::KeyTable::STR_NV3MODEM_PASSWORD, 
			strPass );

		Nv3ModemGetIp	^pNv3ModemGetIp
			= gcnew Nv3ModemGetIp();

		strRet = pNv3ModemGetIp->GetIp( strModemIp, strUsrName, strPass );

		delete strModemIp;
		delete strUsrName;
		delete strPass;

		delete pNv3ModemGetIp;

		if ( strRet == nullptr ) {
			strRet = gcnew String( "Nv3ModemIpGetError" );
		}

	} else {
		nsSvcMHttp::SysLogD		^pSysLogD = gcnew nsSvcMHttp::SysLogD();
		strRet = nsSvcMHttp::SysLogD::m_strPppIp;
		delete pSysLogD;
	}


	delete pIniInfo;

	return strRet;
}