#include "stdafx.h"

#include "MailManage.h"
#include "..\etc\IoIni.h"

#include "..\etc\GetIPBrs\GetIPBrs.h"

#include "MailEnc.h"


using namespace nsSvcMHttp;

nsSvcMHttp::MailReactor::MailReactor()
{
	m_dteLastPolling = System::DateTime::MinValue;
	m_pMSecure = nullptr;

	m_pLogP = nullptr;

	m_Thread_MailPolling = nullptr;
}

nsSvcMHttp::MailReactor::~MailReactor()
{
	ExitMailReactor();

	if ( m_pMSecure != nullptr ) {
		delete 	m_pMSecure;
		m_pMSecure = nullptr;
	}

	if ( m_pLogP != nullptr ) {
		delete m_pLogP;
		m_pLogP = nullptr;
	}
}



void nsSvcMHttp::MailReactor::StartMailReactor( void )
{
	m_pMSecure = gcnew MailSecure();
	m_pMSecure->GetIni();

	m_pLogP = gcnew LogP();
}
void nsSvcMHttp::MailReactor::ExitMailReactor( void )
{
	delete m_pMSecure;
	m_pMSecure = nullptr;

	if ( m_Thread_MailPolling != nullptr ) {
		if ( m_Thread_MailPolling->IsAlive ) {
			m_Thread_MailPolling->Abort();
			m_Thread_MailPolling->Join( 30 );
		}

		delete m_Thread_MailPolling;
	}
	m_Thread_MailPolling = nullptr;

}




void nsSvcMHttp::MailReactor::ReactSession()
{
	bool		blExeChkMail = false;

	if ( System::DateTime::Compare( 
			m_dteLastPolling,
			System::DateTime::MinValue ) == 0 ) {
		blExeChkMail = true;
	} else {

		IniInfo	^pIniInfo
			= gcnew IniInfo();
		
		String ^strPollSec = gcnew String( "300" );
		pIniInfo->ReadIni(
			IniInfo::KeyTable::STR_MAILMANAGE_PO3POLLINGTIME_SEC,
			strPollSec );
		delete pIniInfo;


		double	dblInterval;

		try {
			dblInterval = System::Convert::ToDouble( strPollSec );
		} catch ( Exception ^e ) {
			delete e;

			/* ǂݎG[AftHg 300 bݒ */
			dblInterval = 300;
		}



		System::DateTime	dteNextPoll = DateTime( m_dteLastPolling.Ticks );

		dteNextPoll = dteNextPoll.AddSeconds( dblInterval );

		if ( System::DateTime::Compare( dteNextPoll, System::DateTime::Now ) < 0 ) {
			blExeChkMail = true;
		}
	}

	/* PRS300 gp IP 擾łĂȂȂ */
	/* [M͒f */
	if ( nsSvcMHttp::IPGetBrowse::UseFirstPrs300() ) {
		if ( !nsSvcMHttp::IPGetBrowse::IpGot() ) {
			blExeChkMail = false;
		}
	}





	if ( blExeChkMail ) {

		bool blRet = CheckSvrMail();
		if ( blRet ) {
			m_dteLastPolling = System::DateTime::Now;
			Console::WriteLine( "Mail : polling start" );
			m_pLogP->LogOFWithDate( 0, "Mail : polling start" );
		}

	}



}





nsSvcMHttp::MailDataCage::MailDataCage()
{
	m_srtAttr = nullptr;
	m_strSender = nullptr;
	m_strarReciver = nullptr;

	m_strSubject = nullptr;
	m_byarData = nullptr;
}

nsSvcMHttp::MailDataCage::~MailDataCage()
{
	if ( m_srtAttr != nullptr )
		delete m_srtAttr;
	if ( m_srtAttr != nullptr )
		delete m_strSender;
	if ( m_srtAttr != nullptr )
		delete m_strarReciver;

	if ( m_srtAttr != nullptr )
		delete m_strSubject;
	if ( m_srtAttr != nullptr )
		delete m_byarData;
}

