#include "stdafx.h"

#include "MailSMTP.h"
#include "..\etc\IoIni.h"

#include "..\etc\LogPlus.h"

using namespace nsSvcMHttp;


nsSvcMHttp::MailSend::MailSend() {
	m_s = nullptr;
	m_strarRcptTo = nullptr;
	m_strSubject = nullptr;
	m_strData = nullptr;
}

nsSvcMHttp::MailSend::~MailSend() {

	if ( m_s != nullptr ) {
		m_s->Close();
		delete m_s;
		m_s = nullptr;
	}

	if ( m_strarRcptTo != nullptr ) {
		for( int nCnt = 0 ; nCnt < m_strarRcptTo->Length; nCnt++ ) {
			delete m_strarRcptTo[ nCnt ];
		}
		delete m_strarRcptTo;
		m_strarRcptTo = nullptr;
	}

	if ( m_strSubject != nullptr ) {
		delete m_strSubject;
		m_strSubject = nullptr;
	}

	if ( m_strData != nullptr ) {
		delete m_strData;
		m_strData = nullptr;
	}

}

bool nsSvcMHttp::MailSend::SendMail( void )
{
	if ( m_s == nullptr )
		return false;

	
	IniInfo		^pIniInfo = gcnew IniInfo();
	bool		blRet = false;
	String		^strFromAddress = gcnew String( "" );
	String		^strSvrName     = gcnew String( "" );

	blRet = pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_MAILADDRESS, 
		strFromAddress );
	if ( blRet == false ) {
		delete strFromAddress;
		delete strSvrName;
		delete pIniInfo;
		return blRet;
	}

	blRet = pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_SVRNAME, 
		strSvrName );
	if ( blRet == false ) {
		delete strFromAddress;
		delete strSvrName;
		delete pIniInfo;
		return blRet;
	}

	delete pIniInfo;





	/* M */
	/* 220 msa2-25.plala.or.jp ESMTP server ready Mon, 5 Nov 2007 22:02:55 +0900 */
	array<Byte>		^byarRcv = SocketReadL();



	/* M */
	/* HELO MT[o[ */
	String		^strSend
		= String::Concat( "HELO ",
						  strSvrName, 
						  "\r\n" );
	array<Byte>	^byarSend
		= System::Text::Encoding::ASCII->GetBytes( strSend );

	m_s->Send( byarSend, byarSend->Length,  static_cast<SocketFlags>(0) );




	/* M */
	/* 250 [T[o[ */
	delete byarRcv;
	byarRcv = SocketReadL();



	/* M */
	/* MAIL FROM: <M[AhX> */
	strSend	= String::Concat( "MAIL FROM: <",
							  strFromAddress, 
							  ">\r\n" );
	byarSend
		= System::Text::Encoding::ASCII->GetBytes( strSend );
	delete strSend;

	m_s->Send( byarSend, byarSend->Length,  static_cast<SocketFlags>(0) );
	delete byarSend;




	/* M */
	/* 250 Sender <M[AhX> Ok */
	delete byarRcv;
	byarRcv = SocketReadL();




	/* M */
	/* RCPT TO: <M惁[AhX> */
	for ( int nCnt = 0; nCnt < m_strarRcptTo->Length ; nCnt++ ) {
		String	^strTmpTo = gcnew String( m_strarRcptTo[nCnt] );
			
		if ( strTmpTo->IndexOf( '<' ) >= 0 ) {
			/* 蔲̑M */
			strTmpTo = strTmpTo->Substring( strTmpTo->IndexOf( '<' ) );
		} else {
			String::Concat( "<", strTmpTo, ">" );
		}

		strSend	= String::Concat( "RCPT TO: ",
								  strTmpTo, 
								  "\r\n" );
		delete strTmpTo;


		byarSend
			= System::Text::Encoding::ASCII->GetBytes( strSend );
		delete strSend;

		m_s->Send( byarSend, byarSend->Length,  static_cast<SocketFlags>(0) );
		delete byarSend;

		/* M */
		/* 250 Recipient <M惁[AhX> Ok */
		delete byarRcv;
		byarRcv = SocketReadL();
	}



	/* M */
	/* DATA */
	strSend	= gcnew String( "DATA\r\n" );

	byarSend
		= System::Text::Encoding::ASCII->GetBytes( strSend );
	delete strSend;
	m_s->Send( byarSend, byarSend->Length,  static_cast<SocketFlags>(0) );
	delete byarSend;





	/* M */
	/* 354 Ok Send data ending with <CRLF>.<CRLF> */
	delete byarRcv;
	byarRcv = SocketReadL();



	/* M */
	/* X-Mailer: Nekodemo_wakaru-Mailer */
	/* Subject: xxxxxx */
	/*  */
	/* xxxxxxxx */
	/* */
	/* . */



	strSend	= String::Concat(  
		"X-Mailer: Nekodemo_wakaru-Mailer\r\n"
		"Subject: ", 
		m_strSubject, "\r\n"
		"Content-Type: text/plain;charset=\"iso-2022-jp\";"
		"\r\n"
		);


	byarSend = System::Text::Encoding::ASCII->GetBytes( 
		"X-Mailer: Nekodemo_wakaru-Mailer\r\n"
		"Subject: "
		);

	array<Byte>		^byarSubject
		= System::Text::Encoding::GetEncoding( "iso-2022-jp" )->GetBytes( 
				m_strSubject + 
				"\r\n"			
				"Content-Type: text/plain;charset=\"iso-2022-jp\";"
				"\r\n"
				"\r\n"
			);


	int nOldLength = byarSend->Length;

	array<Byte>::Resize( byarSend, 
				byarSend->Length + byarSubject->Length );
	array<Byte>::Copy(	byarSubject, 0, 
						byarSend, nOldLength, 
						byarSubject->Length );
	delete byarSubject;



	array<Byte>	^byarData 
		= System::Text::Encoding::GetEncoding( "iso-2022-jp" )->GetBytes( m_strData );

	int nOldbyarSendSize = byarSend->Length;
	array<Byte>::Resize( byarSend, byarSend->Length + 
									byarData->Length + 2+ 
									2 + 3 );


	array<Byte>::Copy( byarData, 0 ,byarSend, nOldbyarSendSize , byarData->Length );

	byarSend[ nOldbyarSendSize + byarData->Length     ] = '\r';
	byarSend[ nOldbyarSendSize + byarData->Length + 1 ] = '\n';

	byarSend[ nOldbyarSendSize + byarData->Length + 2 ] = '\r';
	byarSend[ nOldbyarSendSize + byarData->Length + 3 ] = '\n';

	byarSend[ nOldbyarSendSize + byarData->Length + 4 ] = '.';
	byarSend[ nOldbyarSendSize + byarData->Length + 5 ] = '\r';
	byarSend[ nOldbyarSendSize + byarData->Length + 6 ] = '\n';


	m_s->Send( byarSend, byarSend->Length,  static_cast<SocketFlags>(0) );
	delete byarSend;







	/* M */
	/* 250 Message received: 20071105130359.DXTW23102.msa2-25.plala.or.jp@purple.mail.plala.or.jp */
	delete byarRcv;
	byarRcv = SocketReadL();




	/* M */
	/* QUIT */
	strSend	= gcnew String( "QUIT\r\n" );

	byarSend
		= System::Text::Encoding::ASCII->GetBytes( strSend );
	delete strSend;
	m_s->Send( byarSend, byarSend->Length,  static_cast<SocketFlags>(0) );
	delete byarSend;





	/* M */
	/* 221 [T[o[ ESMTP server closing connection */
	delete byarRcv;
	byarRcv = SocketReadL();


	delete byarRcv;
	m_s->Close();


	delete strFromAddress;
	delete strSvrName;
	blRet = true;


	LogP		^pLog = gcnew LogP();
	for ( int nCnt = 0; nCnt < m_strarRcptTo->Length; nCnt++ ) {
		pLog->LogWithDate( String::Concat(
							"[̑M  : To ",
							m_strarRcptTo[ nCnt ] )
						   );
	}
	delete pLog;

	return blRet;

}









Socket^ nsSvcMHttp::MailSend::CreateMailSendSocket( void )
{
	Socket		^s_ret = nullptr;
	String		^strHostString = gcnew String( "localhost" );
	Int32		^int32Port = nullptr;

	IniInfo		^pIniInfo = gcnew IniInfo();
	bool		blRet;

	blRet = pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_SVRNAME , 
		strHostString );

	if ( blRet == false ) {
		delete strHostString;
		delete pIniInfo;
		return s_ret;
	}

	blRet = pIniInfo->ReadIni(
		IniInfo::KeyTable::STR_MAILMANAGE_RETURN_MAILSVR_SVRPORT , 
		int32Port );

	if ( blRet == false ) {
		delete strHostString;
		delete pIniInfo;
		delete int32Port;
		return s_ret;
	}


	

	IPHostEntry^ hostEntry = nullptr;


	hostEntry = Dns::GetHostEntry( strHostString );
	//delete HostString;

	//hostEntry = Dns::GetHostEntry( "127.0.0.1" );
	//hostEntry = Dns::GetHostEntry( "192.168.33.194" );
	//hostEntry = Dns::GetHostEntry( strHostString );


	System::Collections::IEnumerator^ myEnum = hostEntry->AddressList->GetEnumerator();
	while ( myEnum->MoveNext() )
	{
		IPAddress^ address = safe_cast<IPAddress^>(myEnum->Current);
		IPEndPoint^ endPoint = gcnew IPEndPoint( address, (int)int32Port );
		Socket^ tmpS = gcnew Socket( endPoint->AddressFamily,SocketType::Stream,ProtocolType::Tcp );

		try {
			tmpS->Connect( endPoint );


		} catch ( Exception^ e ) {
			delete e;

			delete strHostString;
			delete pIniInfo;
			delete int32Port;

			delete address;
			delete endPoint;
			delete tmpS;
			return s_ret;

		}

		if ( tmpS->Connected )
		{
			/* zXgA|[g\Pbg擾 */
			s_ret = tmpS;
			break;
		} else {
		 continue;
		}
	}

	if ( s_ret == nullptr ) {
		/* \Pbg̐ڑs */

		delete strHostString;
		delete pIniInfo;
		delete int32Port;

		return s_ret;
	}

	int		nTimeOut = 1000;
	s_ret->ReceiveTimeout = nTimeOut;




	delete strHostString;
	delete pIniInfo;
	delete int32Port;


	return s_ret;
}






array<Byte> ^nsSvcMHttp::MailSend::SocketReadL()
{


	array<Byte>	^byarRcv = nullptr;
	array<Byte> ^byarRcvTemp = nullptr;
	byarRcv = nullptr;

	DateTime		dteTimeout = System::DateTime::Now;
	dteTimeout = dteTimeout.AddSeconds( 2 );

	bool blErr = false;


	while ( 1 ) {

		if ( dteTimeout.Compare( dteTimeout, System::DateTime::Now ) < 0 ) {
			/* ^CAEg */

			if ( byarRcv != nullptr ) {
				delete byarRcv;
				byarRcv = nullptr;
			}
			blErr = true;
			break;
		}

		byarRcvTemp = gcnew array<Byte>( 16384 );
		int nRcv = m_s->Receive( byarRcvTemp, byarRcvTemp->Length, static_cast<SocketFlags>(0) );
		
		if ( byarRcv == nullptr ) {
			byarRcv = gcnew array<Byte>( nRcv );
			array<Byte>::Copy( byarRcvTemp, 0, byarRcv , 0, nRcv );
		} else {
			int nOldSize = byarRcv->Length;

			array<Byte>::Resize( byarRcv, nOldSize + nRcv );
			array<Byte>::Copy( byarRcvTemp, 0, byarRcv, nOldSize, nRcv );

		}

		delete byarRcvTemp;

		if ( ( byarRcv[ byarRcv->Length -2 ] == '\r' && 
			   byarRcv[ byarRcv->Length -1 ] == '\n' ) ||
			 ( byarRcv[ byarRcv->Length -1 ] == '\n' )
			   ) {
			break;
		}

	}		



	return byarRcv;

}
