#include "stdafx.h"
#include ".\MiniHttp.h"

#include "secure\hSecure.h"

#include "..\etc\IoIni.h"
#include "..\etc\LogPlus.h"
#include ".\MHttpTray.h"


nsSvcMHttp::MiniHttp::MiniHttp()
{
	m_server = nullptr;
	m_pBuff = nullptr;

	m_HttpRead = nullptr;
	m_HttpRes = nullptr;
	

	m_httpReqs = nullptr;

	m_phttpSecure = nullptr;
	m_pMTray = nullptr;
}


nsSvcMHttp::MiniHttp::~MiniHttp()
{
	ExitMiniHttp();
}


void nsSvcMHttp::MiniHttp::StartMiniHttp()
{	
	Int32		^nServerPort = nullptr;

	IniInfo		^pIniInfo = gcnew IniInfo();
	bool blRet = pIniInfo->ReadIni( IniInfo::KeyTable::STR_HTTPFILE_PORT , nServerPort );
	delete pIniInfo;
	if ( !blRet ) {
		nServerPort = 8080;
	}


	m_HttpRead = gcnew ReadHttpSession();
	m_HttpRes  = gcnew MakeHttpRetData();
	m_pMTray   = gcnew MHttpTray();


	IPAddress^   localAddr = IPAddress::Parse( "127.0.0.1" );

	//m_server = gcnew TcpListener( localAddr , ServerPort );
	m_server = gcnew TcpListener( IPAddress::Any , (int)nServerPort );
	delete nServerPort;
	
	try {
		m_server->Start();
	} catch ( Exception ^e ) {

		LogP		^plogP = gcnew LogP();

		plogP->LogWithDate( "httpd : httpd p̃|[gJ܂B" );
		m_pMTray->AddMessage( "httpd : httpd p̃|[gJ܂B" );

		delete plogP;


		try {
			m_server->Stop();
			delete m_server;
			m_server = nullptr;
		} catch ( System::Exception ^e2 ) {
			delete e2;
		}

		delete this;
		delete e;
		return;
	}

	m_pBuff = gcnew array<Byte>( 1024 );


	m_phttpSecure = gcnew httpSecure();
	m_phttpSecure->GetIni();
	
}


void nsSvcMHttp::MiniHttp::ExitMiniHttp()
{	

	if ( m_pBuff != nullptr ) 
		delete [] m_pBuff;
	m_pBuff = nullptr;

	if ( m_HttpRead )
		delete m_HttpRead;
	if ( m_HttpRes )
		delete m_HttpRes;
	m_HttpRead = nullptr;
	m_HttpRes  = nullptr;



	if ( m_server != nullptr ) {
		m_server->Stop();
		delete m_server;
		m_server = nullptr;
	}

	if ( m_httpReqs != nullptr ) {
		for ( int nCnt = 0 ; nCnt <	m_httpReqs->Count ; nCnt++ ) {
			HttpRequestData ^mHttpData = static_cast<HttpRequestData^>( m_httpReqs[ nCnt ] );
			delete mHttpData;
		}
		delete m_httpReqs;
		m_httpReqs = nullptr;
	}

	if ( m_phttpSecure != nullptr ) {
		delete m_phttpSecure;
		m_phttpSecure = nullptr;
	}

	if ( m_pMTray != nullptr ) {
		delete m_pMTray;
		m_pMTray = nullptr;
	}

}


void nsSvcMHttp::MiniHttp::ReactSession()
{

	if ( m_server == nullptr )
		return;



	/* ڑ̃f[^̑Mꍇ͂ */
	if ( m_httpReqs != nullptr ) {

		if ( m_httpReqs->Count > 0 ) {


			DateTime		dteTimeOut = DateTime::Now;
			dteTimeOut = dteTimeOut.AddSeconds( -15 );

			for ( int nCnt = 0; nCnt < m_httpReqs->Count ; nCnt++ ) {
				HttpRequestData ^pHttpReq
					= static_cast<HttpRequestData^>( m_httpReqs[ nCnt ] );



				int nRcv = -1;
				if ( pHttpReq->m_s->Poll( 1, 
					System::Net::Sockets::SelectMode::SelectRead ) == true ) {
					if ( IsSessionAlive( pHttpReq->m_s ) == true ) {
						nRcv = ReactOneSession( pHttpReq );
					}
				}


				if ( IsSessionAlive( pHttpReq->m_s ) == false ) {
					/* ZbV؂Ăؒf */
					delete pHttpReq;
					m_httpReqs->RemoveAt( nCnt );
					nCnt--;

					Console::WriteLine( "******* : old Session is dead : m_httpReqs->Count:{0}"
						, m_httpReqs->Count );

					continue;
				}




				if ( nRcv > 0 ) {
					/* Vȃf[^̑Mꍇ */
					pHttpReq->m_dteLastConnection 
						= System::DateTime::Now;

						Console::WriteLine( "******* : old Session Use : m_httpReqs->Count:{0}"
							, m_httpReqs->Count );

				} else {


					bool	blTcpTimeOut = false;
					bool	blFomaTimeOut = false;

					if ( DateTime::Compare( 
							pHttpReq->m_dteLastConnection,
							dteTimeOut )
							< 0 ) {
						blTcpTimeOut = true;
					}


					/* SẴf[^MĂȂ */
					/* MV[PXŃ^CAEgĂ */
					/* ؒf */
					/* FOMA ΍ */
					if ( pHttpReq->IsContentsWaiting() ) {
						if ( pHttpReq->IsContentsTimeOut() ) {
							blFomaTimeOut = true;
						}
					}


					if ( blTcpTimeOut  == true ||
						 blFomaTimeOut == true ) {
						/* 20 bԃANZXƔfؒf */
						delete pHttpReq;
						m_httpReqs->RemoveAt( nCnt );
						nCnt--;

						if ( blTcpTimeOut ) {
							Console::WriteLine( "******* : old Session Kill : m_httpReqs->Count:{0}"
							, m_httpReqs->Count );
						} else {

							Console::WriteLine( "******* : old Session Kill(FOMA ^CAEg) : m_httpReqs->Count:{0}"
							, m_httpReqs->Count );
						}
					}


				}

			}
	
		}
	}












	/* VK̐ڑ̏ꍇ̓f[^ */
	while ( m_server->Pending() ) {


		Console::WriteLine( "*******   : New Session" );

		Socket^  s = m_server->AcceptSocket();

		s->SendTimeout = 20000;
		s->ReceiveTimeout = 100;

		HttpRequestData ^pNewHttpReq
					   = gcnew HttpRequestData();

		pNewHttpReq->m_s = s;
		pNewHttpReq->m_dteLastConnection = System::DateTime::Now;

		int nRcv = ReactOneSession( pNewHttpReq );
		if ( nRcv < 0 ) {
			delete pNewHttpReq;
			pNewHttpReq = nullptr;
			continue;
		}

		if ( !pNewHttpReq->IsContentsWaiting() && 
			  pNewHttpReq->IsNotKeepAlive() ) {
			delete pNewHttpReq;
			pNewHttpReq = nullptr;
			continue;
		}

		if ( m_httpReqs == nullptr ) {
			m_httpReqs = gcnew System::Collections::ArrayList();
		}
		m_httpReqs->Insert( m_httpReqs->Count, pNewHttpReq );


	}







}





int nsSvcMHttp::MiniHttp::ReactOneSession( HttpRequestData ^%pHttpReq )
{
	bool blRet = false;


	/*
	if ( IsSessionAlive( pHttpReq->m_s ) == false ) {
		return blRet;
	}
	*/

	

	/* IP F͈͂Ȃ̂mF */

	blRet = m_phttpSecure->RetHttpPermit( 
		((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Address );
	if ( blRet == false ) {
		OutLogSecureWarning(
			((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Address->ToString()
			);
		return blRet;
	}



	blRet = false;



	if ( m_pBuff != nullptr ) {
		delete m_pBuff;
	}
	m_pBuff = gcnew array<Byte>( 1024 );

	
	

	int nRcv = -1;
	try{
		nRcv= pHttpReq->m_s->Receive( m_pBuff );
		blRet = true;
	} catch( Exception ^e ) {
		delete e;
	}

	if ( nRcv <= 0 || blRet == false ) {
		delete m_pBuff;
		m_pBuff = nullptr;

		if ( blRet == false ) {
			OutLogBadSession( 
				((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Address->ToString(), 
				m_pBuff );
		}
		return nRcv;
	}

			



	/* xɎM؂Ȃꍇ */
	if ( m_pBuff->Length == nRcv ) {


		int				nRcvMax = 0;

		array<Byte>		^byarRcvTmp
			= gcnew array<Byte>( 1024 );
		System::DateTime	timeout = System::DateTime::Now.AddMilliseconds( 200 );
		int nRcvOnce = 1;

		while ( nRcvOnce > 0 ) {



			try {
				nRcvOnce = pHttpReq->m_s->Receive( byarRcvTmp );
			} catch ( Exception ^e ) {

				delete e;

				//if ( e == System::Net::Sockets::SocketException ) {
					/* timeoutAȏf[^͗ĂȂ */
					break;
				//}
			}
			if ( nRcvOnce > 0 ) {

				int nOldSize = m_pBuff->Length;

				array<Byte>::Resize( m_pBuff, 
						m_pBuff->Length + nRcvOnce );
				array<Byte>::Copy( byarRcvTmp, 0 ,
								   m_pBuff, nOldSize,
								   nRcvOnce );
				nRcv += nRcvOnce;

				if ( nRcvOnce == byarRcvTmp->Length ) {
					nRcvMax++;


					/* Mf[^悤Ȃ */
					/* xɎMłf[^TCYύX */
					switch ( nRcvMax  ){
					case 3:		case 6:		case 9:
						int nSize;
						if ( nRcvMax == 3 ) {
							nSize = 1024 * 16;
						}
						if ( nRcvMax == 6 )  {
							nSize = 1024 * 128;
						}
						if ( nRcvMax == 9 ) {
							nSize = 1024 * 256;
						}
						delete byarRcvTmp;
						byarRcvTmp = gcnew array<Byte>( nSize );

						break;
					}



				}
			}
			if ( timeout < System::DateTime::Now ) {
				/* ^CAEg */
				/* MV[PXgCɂ葱s鎖ɂ */
				array<Byte>::Resize( m_pBuff, nRcv );
				pHttpReq->AddRcieveBuff( m_pBuff );
				pHttpReq->SetTimerContentsRcv();
				return nRcv;
			}
		
		}

		delete byarRcvTmp;
	}






	array<Byte>::Resize( m_pBuff, nRcv );




	// debug
	System::String		^strRcv;
	strRcv = System::Text::Encoding::ASCII->GetString( m_pBuff );

	if ( strRcv->Length > 0x400 ) {
		String ^strRcvTmp = strRcv->Substring( 0, 0x400 );
		delete strRcv;
		strRcv = strRcvTmp;
	}
	Console::WriteLine( "" );
	Console::WriteLine( "*************************************" );
	Console::WriteLine( "{0}", strRcv );
	Console::WriteLine( "*************************************" );
	Console::WriteLine( "" );
	delete strRcv;




	pHttpReq->AddRcieveBuff( m_pBuff );




	blRet = 
		m_HttpRead->ParseActionData(
			pHttpReq->m_byarRcv,
			((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Address->ToString(),
			((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Port,
			pHttpReq
		);

	/* RecTCYȂ΃f[^҂ */
	if ( !pHttpReq->IsContentsRecieved() ) {
		pHttpReq->ClearUsedData( false );
		pHttpReq->SetTimerContentsRcv();
		return nRcv;
	}
	pHttpReq->DelTimerContentsRcv();


	if ( blRet == false ) {

		/*
		OutLogBadSession( 
			((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Address->ToString(), 
			m_pBuff );
		*/

		System::String		^strIp
			= ((IPEndPoint^)pHttpReq->m_s->RemoteEndPoint )->Address->ToString();

		OutLogBadSession( strIp, m_pBuff );

		delete strIp;
		
		delete m_pBuff;
		m_pBuff = nullptr;

		nRcv = -1;
		return nRcv;
	}











	/* debug */

#if 0
	array<Byte>^SendBytes
		= System::Text::Encoding::ASCII->GetBytes( 
		"HTTP/1.0 200 OK\r\n"
				"Content-Length: 20\r\n"
				"Content-Type: text/html\r\n"
				"\r\n"
				"HELLO\r\n"
				"<a href=\"http://localhost/Top.htm\">Yahoo Link </a>\r\n"
				"HELLO\r\n"
				"<form action=\"/mshttp.cgi\" method=\"post\">\r\n"
				"<input type=submit name=recipient value=test>\r\n"
				"</form>\r\n"

				);
	delete SendBytes;
	SendBytes = nullptr;
	
	
#endif





	m_HttpRes->OutputLog( pHttpReq );


	array<Byte>^SendBytes = nullptr;
	m_HttpRes->ExeAndMakeRetData( pHttpReq, SendBytes );


	blRet = false;
	int nRetDebug;
	try {
		nRetDebug = pHttpReq->m_s->Send( SendBytes, SendBytes->Length, static_cast<SocketFlags>(0) );
		blRet = true;
	} catch ( Exception ^e ) {


		Console::WriteLine( "sending data Error!!" );

		delete e;
		nRcv = -1;
		return nRcv;
	}

	OutLogSendData( SendBytes );
	pHttpReq->ClearUsedData( true );

	

	return nRcv;
}








bool nsSvcMHttp::MiniHttp::IsSessionAlive( System::Net::Sockets::Socket ^s  )
{
	bool blRet = false;


	/*
	if ( s->Poll( 1, 
		System::Net::Sockets::SelectMode::SelectRead ) != true ) {
		return blRet;
	}
	*/



//#if 0

	/* TCP ڑĂ邩H */
	array<Byte>	^byarSendTest = gcnew array<Byte>( 0 );
	try {
		int nSendTest = s->Send( byarSendTest, 0, static_cast<SocketFlags>(0) );
	} catch ( Exception ^e ) {
		/* ZbV͕Ă */
		delete e;
		delete byarSendTest;
		return blRet;
	}
	delete byarSendTest;


//#endif


	blRet = true;
	return blRet;
}





void nsSvcMHttp::MiniHttp::OutLogBadSession( System::String ^strIp, array<System::Byte>^ byarRcvErrData )
{
	

	System::Text::StringBuilder		^stb
		=  gcnew System::Text::StringBuilder();

	stb->Append( "httpd : MG[̂ߐؒf܂B FromIP: " );
	stb->Append( strIp );
	stb->Append( "    Data: " );
	stb->Append( strIp );

	if ( byarRcvErrData != nullptr ) {

		for ( int nCnt = 0 ; nCnt < byarRcvErrData->Length ; nCnt++ ) {

			String ^strPiece = nullptr;

			Char scPiece = System::Convert::ToChar( byarRcvErrData[ nCnt ] );
			if ( Char::IsNumber( scPiece ) || 
				 Char::IsLetter( scPiece ) || 
				 Char::IsSymbol( scPiece )     ) {
				/* \\Ȃ\ */
				strPiece = scPiece.ToString();
			} else {
				strPiece = "-";
			}

			if ( strPiece == "-" ) {

				strPiece += "(";

				unsigned int		uiBuf;
				uiBuf = byarRcvErrData[ nCnt ] & 0xf0;
				uiBuf >>= 4;
				strPiece += String::Format( "{0:x}", uiBuf );
				uiBuf = byarRcvErrData[ nCnt ] & 0x0f;
				strPiece += String::Format( "{0:x}", uiBuf );

				strPiece += ") ";
			}
						
			
			stb->Append( strPiece );

			delete strPiece;

			if ( stb->Length > 0x1000 ) {
				break;
			}
		}
	}


	String		^strLog = stb->ToString();

	LogP		^plogP = gcnew LogP();


	plogP->LogWithDate(   strLog );
	m_pMTray->AddMessage( strLog );

	delete strLog;
	delete plogP;

	delete strLog;
	delete stb;

}















void nsSvcMHttp::MiniHttp::OutLogSecureWarning( System::String ^strIp )
{
	
	String ^strLogStr = String::Concat( 
		"httpd : ZLeBݒɂڑؒf  FromIP: ", 
		strIp );

	LogP		^plogP = gcnew LogP();

	plogP->LogWithDate( strLogStr );
	m_pMTray->AddMessage( strLogStr );

	delete strLogStr;
	delete plogP;


}














void nsSvcMHttp::MiniHttp::OutLogSendData( array<System::Byte>^ byarRcvErrData )
{
	

	


	System::Text::StringBuilder		^stbRcvErrData
		= gcnew System::Text::StringBuilder();
	//String		^strRcvErrData = gcnew String( "" );
	
	if ( byarRcvErrData != nullptr ) {

		for ( int nCnt = 0 ; nCnt < byarRcvErrData->Length ; nCnt++ ) {

			String ^strPiece = nullptr;

			Char scPiece = System::Convert::ToChar( byarRcvErrData[ nCnt ] );
			if ( Char::IsNumber( scPiece )      || 
				 Char::IsLetter( scPiece )      || 
				 Char::IsPunctuation( scPiece ) || 
				 Char::IsWhiteSpace( scPiece )  || 
				 Char::IsSymbol( scPiece )     ) {
				/* \\Ȃ\ */
				strPiece = scPiece.ToString();
			} else {
				strPiece = "-";
			}

			if ( strPiece == "-" ) {

				strPiece += "(";

				unsigned int		uiBuf;
				uiBuf = byarRcvErrData[ nCnt ] & 0xf0;
				uiBuf >>= 4;
				strPiece += String::Format( "{0:x}", uiBuf );
				uiBuf = byarRcvErrData[ nCnt ] & 0x0f;
				strPiece += String::Format( "{0:x}", uiBuf );

				strPiece += ") ";
			}
						
			
			
			stbRcvErrData->Append( strPiece );
			//strRcvErrData = String::Concat( strRcvErrData , strPiece );
			delete strPiece;

			if ( stbRcvErrData->Length >= 0x1024 ) {
				stbRcvErrData->Append( "\n\n....   \n" );
				break;
			}
		}
	}


	stbRcvErrData->Insert(0,  "httpd : ̃f[^𑗐M܂ F" );
	//String ^strLogStr = String::Concat( "httpd : ̃f[^𑗐M܂ F"
	//									, strRcvErrData );



	LogP		^plogP = gcnew LogP();

	//plogP->LogWithDate( strLogStr );
	String		^strRcvErrData = stbRcvErrData->ToString();



	plogP->LogWithDate( strRcvErrData );
	
	delete strRcvErrData;
	delete stbRcvErrData;

	delete plogP;


}




