
#include "stdafx.h"
#include "httpParse.h"

#include "Post\PostAck.h"


#include "..\etc\IoIni.h"
#include "etc\PerEnc.h"
#include "MHttpTray.h"
#include "..\etc\ArrayCmp.h"

using namespace System;

nsSvcMHttp::HttpRequestData::HttpRequestData()
{
	RequestType = 0;

	GET_FileName = nullptr;
	POST_srtData = nullptr;
	CGI_Arg      = nullptr;
	
	UserAppType = 0;

	ClientIp = nullptr;

	m_srtAttr = nullptr;
	m_s = nullptr;

	m_byarRcv = nullptr;
	m_byarContents = nullptr;

	m_dteRcvLast = System::DateTime::MinValue;

	m_arUpLoadDatas = nullptr;
}


nsSvcMHttp::HttpRequestData::~HttpRequestData()
{
	if ( GET_FileName != nullptr ) {
		delete GET_FileName;
		GET_FileName = nullptr;
	}

	if ( POST_srtData != nullptr ) {

		System::Collections::IList		^ilist
			= POST_srtData->GetKeyList();

		for ( int nCnt = ilist->Count - 1 ; nCnt >= 0 ; nCnt-- ) {

			String		^strKey
				= static_cast<String^>( ilist[ nCnt ] );
			delete POST_srtData[ strKey ];
			delete strKey;
		}

		delete ilist;

		delete POST_srtData;
		POST_srtData = nullptr;
	}
	if ( CGI_Arg != nullptr ) {
		delete CGI_Arg;
		CGI_Arg = nullptr;
	}
	
	if ( ClientIp != nullptr ) {
		delete ClientIp;
		ClientIp = nullptr;
	}

	if ( m_srtAttr != nullptr ) {

		System::Collections::IList	^ilist
			= m_srtAttr->GetKeyList();

		for( int nCnt = 0; nCnt < ilist->Count; nCnt++ ) {

			String	^strKey;
			String	^strKeyData;

			strKey = static_cast<String^>( ilist[ nCnt ] );
			strKeyData = static_cast<String^>( m_srtAttr[ ilist[ nCnt ] ] );

			delete strKey;
			delete strKeyData;


		}

		delete ilist;
		delete m_srtAttr;
		m_srtAttr = nullptr;

	}

	if ( m_s != nullptr ) {
		m_s->Close();
		delete m_s;
	}
	m_s = nullptr;

	if ( m_byarRcv != nullptr ) {
		delete m_byarRcv;
		m_byarRcv = nullptr;
	}

	if ( m_byarContents != nullptr ) {
		delete m_byarContents;
		m_byarContents = nullptr;
	}






	if ( m_arUpLoadDatas != nullptr ) {


		for( int nCnt = 0; nCnt < m_arUpLoadDatas->Length; nCnt++ ) {

			delete m_arUpLoadDatas[ nCnt ]->m_strFileName;
			delete m_arUpLoadDatas[ nCnt ]->m_strAttr;
			delete m_arUpLoadDatas[ nCnt ]->m_byarFileData;
			delete m_arUpLoadDatas[ nCnt ];
		}

		delete [] m_arUpLoadDatas;

	}



	

}

bool nsSvcMHttp::HttpRequestData::IsNotKeepAlive( void )
{
	bool		blRet = false;

	if ( m_srtAttr != nullptr ) {

		String		^strKeepAlive
			= gcnew String( "Connection: " );
		if ( m_srtAttr->ContainsKey( strKeepAlive ) ) {
				
			System::String ^strData = 
					static_cast<String^>( m_srtAttr[ strKeepAlive ] );

			if ( strData->IndexOf( "Close" ) >= 0 ) {
				blRet = true;
			}
			
			delete strData;
		}

		delete strKeepAlive;

	}

	return blRet;
	
}


bool nsSvcMHttp::HttpRequestData::IsContentsRecieved( void )
{
	int nHeaderContentsSize = -1;

	if ( m_srtAttr != nullptr ) {

		String		^strKey
			= gcnew String( "Content-Length:" );
		if ( m_srtAttr->ContainsKey( strKey ) ) {
				
			System::String ^strData = 
					static_cast<String^>( m_srtAttr[ strKey ] );

			try {
				nHeaderContentsSize = System::Convert::ToInt32( strData );
			} catch ( Exception ^e ) {
				delete e;
			}

			delete strData;
		} else {

			/* Content-Length ĂȂꍇ */
			/* MĎsȂ */
			delete strKey;
			return true;
		}

		delete strKey;

	}

	if ( nHeaderContentsSize < 0 ) {
		return false;
	}


	if ( m_byarContents == nullptr ) {
		return false;
	}
	if ( m_byarContents->Length != nHeaderContentsSize ) {


		
		
		System::Console::WriteLine( 
			String::Format( "tcp Recieced length : {0}, "
							"Content-Length :{1}, ",
							m_byarContents->Length, nHeaderContentsSize ) );
		return false;
	}


	return true;
}



bool nsSvcMHttp::HttpRequestData::IsContentsWaiting( void )
{
	if ( m_dteRcvLast != System::DateTime::MinValue ) {
		return true;
	}
	return false;
}

bool nsSvcMHttp::HttpRequestData::IsContentsTimeOut( void )
{

	if ( m_dteRcvLast == System::DateTime::MinValue ) {
		return false;
	}


	if ( System::DateTime::Compare( 
			m_dteRcvLast, 
			System::DateTime::Now ) < 0 ) {
		return true;
	}
	return false;
}

void nsSvcMHttp::HttpRequestData::SetTimerContentsRcv( void )
{
	m_dteRcvLast = System::DateTime::Now;

	m_dteRcvLast = m_dteRcvLast.AddSeconds( 30 );
}


void nsSvcMHttp::HttpRequestData::DelTimerContentsRcv( void )
{
	m_dteRcvLast = System::DateTime::MinValue;
}





void nsSvcMHttp::HttpRequestData::AddRcieveBuff( array<Byte> ^%byarNewRcv )
{


	if ( m_byarRcv != nullptr ) {

		int		nOldSize = m_byarRcv->Length;

		array<Byte>::Resize( m_byarRcv, m_byarRcv->Length + byarNewRcv->Length );
		array<Byte>::Copy( byarNewRcv, 0, 
						   m_byarRcv, nOldSize, 
						   byarNewRcv->Length );

	} else {
		m_byarRcv = gcnew array<Byte>( byarNewRcv->Length );
		array<Byte>::Copy( byarNewRcv, 0, 
						   m_byarRcv, 0, 
						   byarNewRcv->Length );
	}
	
}



void nsSvcMHttp::HttpRequestData::ClearUsedData( bool blRcvBufClear ) 
{
	RequestType = 0;

	if ( GET_FileName != nullptr ) {
		delete GET_FileName;
		GET_FileName = nullptr;
	}

	if ( POST_srtData != nullptr ) {
		delete POST_srtData;
		POST_srtData = nullptr;
	}

	if ( CGI_Arg != nullptr ) {
		delete CGI_Arg;
		CGI_Arg = nullptr;
	}

	UserAppType = 0;

	if ( m_srtAttr != nullptr ) {
		for ( int nCnt = 0; nCnt < m_srtAttr->Count; nCnt++ ) {
			String ^strKey
				= static_cast<String^>( m_srtAttr->GetKey( nCnt ) );
			String ^strData
				= static_cast<String^>( m_srtAttr[ strKey ] );

			delete strKey;
			delete strData;
		}
		delete m_srtAttr;
		m_srtAttr = nullptr;
	}


	//m_dteLastConnection = System::DateTime::MinValue;


	if ( blRcvBufClear == true ) {
		if ( m_byarRcv != nullptr ) {
			delete m_byarRcv;
			m_byarRcv = nullptr;
		}
	}


	if ( m_byarContents != nullptr ) {
		delete m_byarContents;
		m_byarContents = nullptr;
	}


	if ( m_arUpLoadDatas != nullptr ) {
		for ( int nCnt = 0; nCnt < m_arUpLoadDatas->Length; nCnt++ ) {
			HttpRequestData_Upload		^pUpld
				= static_cast<HttpRequestData_Upload^>( m_arUpLoadDatas[ nCnt ] );

			delete pUpld;
		}
		delete m_arUpLoadDatas;
		m_arUpLoadDatas = nullptr;
	}

	m_dteRcvLast = System::DateTime::MinValue;
}







nsSvcMHttp::ReadHttpSession::ReadHttpSession()
{
}

nsSvcMHttp::ReadHttpSession::~ReadHttpSession()
{
}


bool nsSvcMHttp::ReadHttpSession::ParseActionData
			(   array<Byte> ^byarRcv, 
				String ^strRemoteIp,
				int     iRemotePort,
				HttpRequestData ^% pHttpReq )
{


	bool		blRet = false;


	/* sƂɃf[^𕪊A\[g */
	System::Collections::SortedList		^srtlist;
	srtlist = gcnew System::Collections::SortedList();


	bool		blCrlfRtnMode = false;

	/*<keyword> */
	/*<keyword>:*/
	/*<keyword>=*/
	/* 擾 */
	int		nParseCnt = 0;
	int		nPosContents = -1;
	int		nPosContentsLength;
	while ( nParseCnt < byarRcv->Length )
	{
		//int ParseCntNew =
		int nSpace  = array<Byte>::IndexOf( byarRcv, Byte(' '), nParseCnt );
		int nCorron = array<Byte>::IndexOf( byarRcv, Byte(':'), nParseCnt );
		//int nEqual  = array<Byte>::IndexOf( byarRcv, Byte('='), nParseCnt );

		int nKey = nSpace;
		if ( nKey == -1 ) {
			nKey = nCorron;
			//if ( nKey == -1 )
			//	nKey = nEqual;
		}

		if ( nKey == -1 ) {
			/* FoȂf[^͓ǂݎ̂ */
			nParseCnt++;
			continue;
		}

		if ( nSpace != -1 )
			if ( nKey > nSpace )
				nKey = nSpace;

		if ( nCorron != -1 )
			if ( nKey > nCorron )
				nKey = nCorron;

		//if ( nEqual != -1 )
		//	if ( nKey > nEqual )
		//		nKey = nEqual;


		/* L[擾 */
		array<Byte>		^byarKey;
		byarKey = gcnew array<Byte>( (nKey+1) - nParseCnt );
		array<Byte>::Copy( byarRcv, nParseCnt, byarKey, 0, nKey-nParseCnt +1 );
		
		String ^strKey = System::Text::Encoding::ASCII->GetString( byarKey );
		delete byarKey;

		/* e擾 */
		int nRtnP = array<Byte>::IndexOf( byarRcv, Byte( '\n' ), nKey );
		if (nRtnP == -1 ) {
			nRtnP = byarRcv->Length;

#if 0
			/* aaa=xxx&bbb=yyy Ƃ`ł & 鎞̑΍ */
			if ( nKey == nEqual ) {
				int nRtnAnd = array<Byte>::IndexOf( byarRcv, Byte( '&' ), nKey );
				if ( nRtnAnd != -1 ) {
					nRtnP = nRtnAnd - 1;
				}
			}
#endif
		}

		if ( byarRcv[ nRtnP-1] == '\r' )
			nRtnP--;

		array<Byte>		^byarContents;
		byarContents = gcnew array<Byte>( (nRtnP-1) - (nKey+1) +1 );
		array<Byte>::Copy( byarRcv, nKey+1, byarContents, 0, (nRtnP-1)-(nKey+1) +1 );

		String ^strContents = System::Text::Encoding::ASCII->GetString( byarContents );
		delete byarContents;

		srtlist->Add( strKey, strContents );
		delete strKey;
		delete strContents;

		

		nParseCnt = nRtnP + 1;
		if ( nParseCnt < byarRcv->Length ) {
			if ( byarRcv[ nParseCnt ] == '\n' ) {
				nParseCnt++;
			} else if ( nParseCnt+1 < byarRcv->Length ) {
				if ( byarRcv[ nParseCnt   ] == '\r' &&
					 byarRcv[ nParseCnt+1 ] == '\n' ) {
					nParseCnt += 2;
				}
			}




			if ( nParseCnt < byarRcv->Length - 1 ) {
				if ( byarRcv[ nParseCnt ] == '\r' ) {
					if ( byarRcv[ nParseCnt + 1 ] == '\n' ) {
						nParseCnt += 2;
						blCrlfRtnMode = true;
						nPosContents = nParseCnt;
						nPosContentsLength = byarRcv->Length - nPosContents;
						break;
					}

				}
			}


			if ( nParseCnt < byarRcv->Length ) {
				if ( byarRcv[ nParseCnt ] == '\n' ) {
					nParseCnt++;
					nPosContents = nParseCnt;
					nPosContentsLength = byarRcv->Length - nPosContents;
					break;
				}
			} else {
				/* f[^͓ǂݎr */
				break;
			}

		}

	}
	
	if ( nPosContents == -1 ) {

		for( int nCnt = 0; nCnt < srtlist->Count; nCnt++ ) {
			String		^strKey, ^strKeyData;

			strKey = dynamic_cast<String^>( srtlist->GetKey( 0 ) );
			strKeyData = dynamic_cast<String^>( srtlist[ strKey ] );
			delete strKey;
			delete strKeyData;
		}
		delete srtlist;

		return blRet;
	}


	bool	blMultiPart = false;
	String ^strContentType = nullptr;
	if ( srtlist->ContainsKey( "Content-Type:" ) ) {

		strContentType = static_cast<String^>( srtlist[ "Content-Type:" ] );

		String ^strMultiPart = gcnew String( "multipart/form-data;" );
		if ( strContentType->IndexOf( strMultiPart ) >= 0 ) {
			
			/* }`p[g */
			blMultiPart = true;
		}
		delete strMultiPart;

	}







	array<HttpRequestData_Upload^>		^arUpLoadDatas = nullptr;

	if ( blMultiPart ) {

		bool blErr = false;

		/************************/
		/*  }`p[g̏ꍇ  */
		/************************/

		String	^strBorderKey = gcnew String( "boundary=" );
		String	^strBorder = nullptr;

		if ( strContentType->IndexOf( strBorderKey ) >= 0 ) {

			strBorder = "--" + strContentType->Substring( 
				strContentType->IndexOf( strBorderKey ) + 9 );
		}
		delete strBorderKey;


		if ( strBorder != nullptr ) {


			/* {[_[CɃf[^ǂݎ */
			//nParseCnt
			array<Byte>	^byarBorder =
				System::Text::ASCIIEncoding::ASCII->GetBytes( strBorder );

			int nFind, nEnd;

			nFind = ArrayCmp::ByteFind( byarRcv, nParseCnt, byarBorder );

			array<Byte>			^byarCrlf = gcnew array<Byte>( 2 );
			byarCrlf[ 0 ] = '\r';		byarCrlf[ 1 ] = '\n';

			array<Byte>			^byarNameKey = System::Text::Encoding::ASCII->GetBytes( 
									"name=" );


			array<Byte>			^byarContentsTypeKey = 
											 System::Text::Encoding::ASCII->GetBytes( 
											 "Content-Type: " );


			array<Byte>			^byarFileNameKey =
				System::Text::Encoding::ASCII->GetBytes( "filename=\"" );






			if ( nFind >= 0 ) {
				while ( nFind < byarRcv->Length ) {


					nEnd = ArrayCmp::ByteFind( byarRcv, nFind + byarBorder->Length, byarBorder );
					if ( nEnd < 0 ) {
						/* Mf[^s */
						blErr = true;
						break;
					}



					/******************************/
					/* nFind -> nEnd ܂łp[X */
					/******************************/

					/* ŏ̉sʒu擾 */
					int		nRtn;
					nRtn = ArrayCmp::ByteFind( byarRcv, nFind + byarBorder->Length + 1, byarCrlf );
					if ( nRtn < 0 )
						nRtn = ArrayCmp::ByteSearch( byarRcv, nFind + byarBorder->Length + 1, '\n' );
					if ( nRtn < 0 ) {
						/* sʒuȂIFoȂf[^ */
						blErr = true;
						break;
					}


					/* name=  */
					int nIndexName = ArrayCmp::ByteFind( byarRcv, nFind, byarNameKey );
					if ( nIndexName < 0 ) {
						/* name= ȂIFoȂf[^ */
						blErr = true;
						break;
					}

					if ( nIndexName >= nRtn ) {
						/* name= K؂ȈʒuɌȂIFoȂf[^ */
						blErr = true;
						break;
					}



					/* name ̒ "...." 擾 */
					int nIndex = ArrayCmp::ByteSearch( byarRcv, nIndexName+6, '\"' );
					if ( nIndex < 0 ) {
						blErr = true;
						break;
					}

					array<Byte>			^byarContentsKey = nullptr;

					byarContentsKey = gcnew array<Byte>( nIndex - 1 - (nIndexName + 6) + 1 );
					array<Byte>::Copy( byarRcv, nIndexName + 6, 
										byarContentsKey, 0, 
										nIndex - 1 - (nIndexName + 6) + 1 );

					String ^strKey = System::Text::Encoding::ASCII->GetString( byarContentsKey );
					delete byarContentsKey;


					nFind = nIndex + 1;


					/* filename... 邩H */
					nIndex = ArrayCmp::ByteFind( byarRcv, nFind, byarFileNameKey );
					
					if ( nIndex >= 0 ) {
					
						/* t@CAbv[hƔF */

						nRtn = ArrayCmp::ByteFind( byarRcv, nIndex+10, byarCrlf );
						if ( nRtn < 0 ) {
							nRtn = ArrayCmp::ByteSearch( byarRcv, nIndex+10, '\n' );
							if ( nRtn < 0 ) {
								/* FoȂf[^AI */
								delete strKey;
								blErr = true;
								break;
							}
						}

						int nIndex2 = ArrayCmp::ByteSearch( byarRcv, nIndex+10, '\"' );
						if ( nIndex < 0 || nIndex > nRtn ) {
							/* FoȂf[^AI */
							delete strKey;
							blErr = true;
							break;
						}


						array<Byte>			^byarUploadFileName
							= gcnew array<Byte>( nIndex2 - 1 - (nIndex + 10) + 1 );
						array<Byte>::Copy( byarRcv, nIndex + 10,
											byarUploadFileName, 0, 
											     nIndex2 - 1 - (nIndex + 10) + 1 );

						/* t@Cۑ */
						PerEnc		^pEnc = gcnew PerEnc();

						String		^strFileNameContent 
										  = pEnc->GetPerEnc( byarUploadFileName );
						delete byarUploadFileName;
						delete pEnc;


						/* Content-Type ̍ss̎܂œǂݔ΂ */
						nIndex = ArrayCmp::ByteFind( byarRcv, nIndex, byarContentsTypeKey );
						if ( nIndex < 0 ) {
							delete strKey;
							delete strFileNameContent;
							blErr = true;
							break;
						}



						nIndex += byarContentsTypeKey->Length;
						int nIndexBuf;
						nIndexBuf = ArrayCmp::ByteFind( byarRcv, nIndex, byarCrlf );
						if ( nIndexBuf < 0 ) {
							nIndexBuf = ArrayCmp::ByteSearch( byarRcv, nIndex, '\n' );
							if ( nIndexBuf < 0 ) {
								delete strKey;
								delete strFileNameContent;
								blErr = true;
								break;
							} else {
								nIndex++;
							}
						} else {
							nIndex = nIndexBuf + 2;
						}
						




						if (        nIndex + 3 < byarRcv->Length   &&
								    byarRcv[ nIndex     ] == '\r' && 
								    byarRcv[ nIndex + 1 ] == '\n' ) {
							nIndex += 2;
						} else if ( nIndex + 2 < byarRcv->Length   &&
								    byarRcv[ nIndex ] == '\n'  ) {
							nIndex++;
						}

						if ( nIndex >= byarRcv->Length ) {
							/* rŃf[^؂ĂAsȃTCŶ */
							/* I */
							delete strKey;
							delete strFileNameContent;
							blErr = true;
							break;
						}




						int nIndexFileEnd = nEnd - 1;
						if ( byarRcv[ nIndexFileEnd ] == '\n' ) 
							nIndexFileEnd--;
						/* ʂłt@CII */
						/*  dlȂB */
						/* sR[hǂőĂĂ邩ǂŌ */
						/* ؂邩HHH */
						if ( blCrlfRtnMode == true && byarRcv[ nIndexFileEnd ] == '\r' )				
							nIndexFileEnd--;



						/* oCif[^擾 */
						array<Byte>			^byarFile;
						byarFile = gcnew array<Byte>( nIndexFileEnd - nIndex + 1 );
						array<Byte^>::Copy( byarRcv, nIndex, 
											byarFile, 0, 
											nIndexFileEnd - nIndex + 1 );

						nFind = nIndex + nEnd - nIndex + 1;





						/* t@C`F[ǉ */
						array<HttpRequestData_Upload^> ^arUploadDatas_tmp = nullptr;
						if ( arUpLoadDatas == nullptr ) {
							arUploadDatas_tmp = gcnew array<HttpRequestData_Upload^>( 1 );
						} else {
							arUploadDatas_tmp = gcnew array<HttpRequestData_Upload^>( 
										arUpLoadDatas->Length + 1 );

							for ( int nCnt = 0; nCnt < arUpLoadDatas->Length; nCnt++ ) {
								arUploadDatas_tmp[ nCnt ] = arUpLoadDatas[ nCnt ];
							}
						}
						
						delete arUpLoadDatas;

						arUpLoadDatas = arUploadDatas_tmp;

						arUpLoadDatas[ arUpLoadDatas->Length - 1 ]
							= gcnew HttpRequestData_Upload();
						
						
						HttpRequestData_Upload^		tmp;

						tmp = arUpLoadDatas[ arUpLoadDatas->Length - 1 ];


						tmp->m_byarFileData = byarFile;
						tmp->m_strAttr      = strKey;
						tmp->m_strFileName  = strFileNameContent;



					} else {

						/* s΃XLbv */
						for ( int nCnt = 0; nCnt < 2; nCnt++ ) {
							if ( nFind >= byarRcv->Length ) {
								blErr = true;
								break;
							}
							if ( byarRcv[ nFind ] == '\r' ) 
								nFind++;
							if ( byarRcv[ nFind ] == '\n' ) 
								nFind++;
						}


						nRtn = ArrayCmp::ByteFind( byarRcv, nFind, byarCrlf );
						if ( nRtn < 0 ) {
							nRtn = ArrayCmp::ByteSearch( byarRcv, nFind, '\n' );
							if ( nRtn < 0 ) {
								/* sȂAG[ */
								blErr = true;
								break;
							}							
						}


						array<Byte>	^byarValue
									= gcnew array<Byte>( nRtn - 1 -  nFind + 1 );
						array<Byte>::Copy( byarRcv, nFind, 
											byarValue, 0, 
											byarValue->Length );

						String ^strValue = 
								System::Text::Encoding::ASCII->GetString( byarValue );
						nFind = nFind + byarValue->Length;
						delete byarValue;


						/* 擾f[^ǉ */						
						srtlist->Add( strKey, strValue );

					}












					/* I[H */
					if ( nEnd + byarBorder->Length + 2 < byarRcv->Length ) {
						if ( byarRcv[ nEnd + byarBorder->Length      ] == '-' && 
							 byarRcv[ nEnd + byarBorder->Length + 1  ] == '-' ) {

							int nContntsEndRtn = nEnd + byarBorder->Length + 2;
							
#if 0
							/* Ōオ LF? */
							if ( nContntsEndRtn < byarRcv->Length ) {
								if ( byarRcv[ nContntsEndRtn    ] == '\n' ) {
									/* Ō̉s contents O */
									/* http vgRI̍}Ƃ݂Ȃ */									
									/* IE  multi-part 쎞̕sHHH */
									nPosContentsLength -=1;
								}
							}
							
							/* Ōオ CRLF? */
							if ( nContntsEndRtn + 1 < byarRcv->Length ) {
								if ( byarRcv[ nContntsEndRtn    ] == '\r' && 
									byarRcv[ nContntsEndRtn + 1 ] == '\n' ) {
									nPosContentsLength -=2;
								}
							}
#endif


							/* I[̂ߏI */
							break;
						}
					}

					nFind = nEnd;
				}


			}

			delete byarBorder;
			delete byarCrlf;
			delete byarNameKey;
			delete byarFileNameKey;
			delete byarContentsTypeKey;




			if ( blErr ) {
				/* FłȂMf[^AI */
				return false;
			}
		}

		delete strBorder;


	} else {

		/******************************/
		/*  }`p[gł͂Ȃꍇ  */
		/******************************/

		//nParseCnt
		int nKey = nParseCnt;

		while ( nParseCnt < byarRcv->Length ) {

			int nEqual = ArrayCmp::ByteSearch( byarRcv, nKey, '=' );

			if (nEqual < 0 ) 
				break;

			/* "abcd=" L[ */
			String ^strKey = 
				System::Text::Encoding::ASCII->GetString( byarRcv, nKey, nEqual - nKey + 1 );

			int nContent = ArrayCmp::ByteSearch( byarRcv, nKey, '&' );
			if ( nContent < 0 ) {
				nContent = ArrayCmp::ByteSearch( byarRcv, nKey, '\r' );
			}
			if ( nContent < 0 ) {
				nContent = ArrayCmp::ByteSearch( byarRcv, nKey, '\n' );
			}
			if ( nContent < 0 ) {
				nContent = byarRcv->Length;
			}


			String ^strContents = 
				System::Text::Encoding::ASCII->GetString( byarRcv, nEqual + 1, 
						nContent - 1 - (nEqual + 1) + 1 );
				

			srtlist->Add( strKey, strContents );
			
			if ( nContent < byarRcv->Length ) {
				if ( byarRcv[ nContent ] == '\r' ||
					 byarRcv[ nContent ] == '\n' ) {
					break;
				}
			}

			nKey      = nContent + 1;
			nParseCnt = nKey;
		}

	}
	if ( strContentType != nullptr )
		delete strContentType;







	/* http Rec̓ep[X */



	pHttpReq->m_srtAttr			= srtlist;
	pHttpReq->m_arUpLoadDatas	= arUpLoadDatas;

	/****************************/
	/* GET/POST/orCGI 𔻕  */
	/****************************/

	if ( srtlist->ContainsKey( "GET " )) {
		pHttpReq->RequestType = pHttpReq->REQUESTType_GET;



		/* HTTP ̑O܂ł擾 */
		String ^strArg;
		strArg = static_cast<String^> ( srtlist[ "GET " ] );

		int nHttpPos = strArg->IndexOf( " HTTP" );
		if ( nHttpPos ) {
			strArg = strArg->Substring(0, nHttpPos );
		}


		PerEnc		^pPerEnc = gcnew PerEnc();
		pHttpReq->GET_FileName = pPerEnc->GetPerEncUTF8( strArg );
		delete pPerEnc;

		/* t@C cgi Ă CGI type ɕύX */
		int nCgiPos = strArg->IndexOf( ".cgi" );
		if ( nCgiPos >= 0 ) {
			pHttpReq->RequestType = pHttpReq->REQUESTType_CGI;

			pHttpReq->CGI_Arg =
				strArg->Substring( nCgiPos+3 );
		}
		delete strArg;

	} else if ( srtlist->ContainsKey( "POST " )) {
		pHttpReq->RequestType = pHttpReq->REQUESTType_POST;


		/* HTTP ̑O܂ł擾 */
		String ^strArg;
		strArg = static_cast<String^> ( srtlist[ "POST " ] );

		int nHttpPos = strArg->IndexOf( " HTTP" );
		if ( nHttpPos ) {
			strArg = strArg->Substring(0, nHttpPos );
		}
		pHttpReq->GET_FileName = strArg;



		/* XXX= ƂȂĂ镔SďW߂ */
		System::Collections::IList 
			^illist = srtlist->GetKeyList();
		String		^strPostLine = "";


		int nAttrCnt = 0;
		for( int nCnt = illist->Count -1; nCnt >= 0 ; nCnt-- ) {
			String ^strKey  = static_cast<String^> ( illist[ nCnt ] );


			String ^strData = static_cast<String^> ( srtlist[ strKey ] );

			if ( strKey->IndexOf( "=" ) >= 0 ) {
				strPostLine = String::Concat( strKey,  strData );
				break;
			}

			delete strKey;
		}
		delete illist;



		pHttpReq->POST_srtData = gcnew System::Collections::SortedList();


		if ( strPostLine != nullptr ) {

			int nPosTop = 0;
			int nPos = strPostLine->IndexOf( "&" );

			if ( nPos >= 0 ) {

				while ( nPos >= 0 ) {
					String ^strBuf =
						strPostLine->Substring( nPosTop, (nPos-1) -nPosTop + 1 );

					int nEqual = strBuf->IndexOf( "=" );

					if ( nEqual >= 0 ) {
						/* XXX=YYYY */
						

						/* XXX= */
						String ^strKey = 
							strBuf->Substring( 0, nEqual+1);
						/* YYY */
						String ^strKeyData = strBuf->Substring( nEqual+1 );

						pHttpReq->POST_srtData->Add( strKey, strKeyData );

						delete strKey;
						delete strKeyData;

					}

					nPosTop = nPos+1;
					
					if ( nPosTop >= strPostLine->Length ) {
						break;
					}

					nPos = strPostLine->IndexOf( "&", nPosTop );

					delete strBuf;

					if ( nPos == -1 ) {
						
						if ( nPosTop < strPostLine->Length ) {
							nPos = strPostLine->Length;
						} else {
							break;
						}
					}

				}






			} else {

				int nEqual = strPostLine->IndexOf( "=" );

				/* XXX= */
				String ^strKey = 
					strPostLine->Substring( 0, nEqual+1);
				/* YYY */
				String ^strKeyData = strPostLine->Substring( nEqual+1 );

				pHttpReq->POST_srtData->Add( strKey, strKeyData );


				delete strKey;
				delete strKeyData;
			}


		}
		delete strPostLine;


	} else {
		/* ̃\bhȊO͔Ή̂߃X[ */

		return blRet;

	}



	/****************************/
	/* XXX: YYYY𔻕          */
	/****************************/
	/* USer-Agent: */
	pHttpReq->UserAppType = HttpRequestData::USERAPPTYPE_ELSE;
	if ( srtlist->ContainsKey( "User-Agent:" ) ) {

		String ^strAgentArg = 
			static_cast<String^>( srtlist[ "User-Agent:" ] );

		if ( strAgentArg->IndexOf( "Windows" ) != -1    || 
			 strAgentArg->IndexOf( "Macintosh" ) != -1    || 
			 strAgentArg->IndexOf( "UNIX" ) != -1 
			) {
			pHttpReq->UserAppType = HttpRequestData::USERAPPTYPE_PC;
		}
		else if ( strAgentArg->IndexOf( "DoCoMo" ) != -1 ) {
			pHttpReq->UserAppType = HttpRequestData::USERAPPTYPE_DOCOMO;
		}

		delete strAgentArg;
	}



	/* Mf[^ۑ */
	if ( pHttpReq->m_byarRcv != nullptr ) 
		delete pHttpReq->m_byarRcv;
	pHttpReq->m_byarRcv = gcnew array<Byte>( byarRcv->Length );
	array<Byte>::Copy( byarRcv, 0 , 
					   pHttpReq->m_byarRcv, 0, 
						byarRcv->Length );

	/* Recۑ */
	if ( nPosContentsLength >= 0 ) {
		if ( pHttpReq->m_byarContents != nullptr )
			delete pHttpReq->m_byarContents;

		pHttpReq->m_byarContents = 
			gcnew array<Byte>( nPosContentsLength );

		array<Byte>::Copy( byarRcv, nPosContents, 
					   pHttpReq->m_byarContents, 0, 
						nPosContentsLength );
	}

	

	pHttpReq->ClientIp = gcnew String( strRemoteIp );
	pHttpReq->ClientPort = iRemotePort;
	

	blRet = true;
	return blRet;	

}




nsSvcMHttp::MakeHttpRetData::MakeHttpRetData()
{
	m_strHttpDir = nullptr;
	m_strHttp_DefaultFile = nullptr;

	IniInfo		^pIniInfo;
	pIniInfo = gcnew IniInfo();

	m_strHttpDir = gcnew String( "" );
	bool blRet = 
		pIniInfo->ReadIni( IniInfo::KeyTable::STR_HTTPFILE_TOPDIR, 
					m_strHttpDir );

	m_strHttp_DefaultFile = gcnew String( "Top.htm" );
	blRet = 
		pIniInfo->ReadIni( IniInfo::KeyTable::STR_HTTPFILE_DEFAULTNAME, 
					m_strHttp_DefaultFile );


	m_pLogP = gcnew LogP();

	delete pIniInfo;

}

nsSvcMHttp::MakeHttpRetData::~MakeHttpRetData()
{
	if ( m_strHttpDir != nullptr )
		delete 	m_strHttpDir;
	m_strHttpDir = nullptr;

	if ( m_strHttp_DefaultFile != nullptr )
		delete 	m_strHttp_DefaultFile;
	m_strHttp_DefaultFile = nullptr;


	delete m_pLogP;
	m_pLogP = nullptr;

}


bool nsSvcMHttp::MakeHttpRetData::ExeAndMakeRetData(  nsSvcMHttp::HttpRequestData ^HttpRcvInf,  array<Byte> ^%byarSend )
{
	bool		blRet = false;
	bool		blErr = false;

	/* sڂ̃R}h */
	String		^strAckStr = nullptr;

	/*  */
	System::Collections::SortedList		^srtlAttr
		= gcnew System::Collections::SortedList();
	
	/* e */
	array<Byte>							^byarContents = nullptr;



	/* wb_( Ƃ肠͌Œŏo͂Ă ) */

	String ^strContent         = gcnew String( "Content-Length: " );
	String ^strContentData     = gcnew String( "Content-Length: " );

	String ^strContentType     = gcnew String( "Content-Type: " );
	String ^strContentTypeData = gcnew String( "text/html" );

	srtlAttr->Add( strContent,     strContentData );
	srtlAttr->Add( strContentType, strContentTypeData );

	delete strContent;
	delete strContentData;
	delete strContentType;
	delete strContentTypeData;



	/* Keep-Alive: timeout=5, max=100  */
	String ^strKeepAlive     = "Keep-Alive: ";
	String ^strKeepAliveData = "timeout=5, max=100";
	srtlAttr->Add( strKeepAlive,     strKeepAliveData );
	delete strKeepAlive;
	delete strKeepAliveData;

    /* Connection: Keep-Alive          */
	String ^strConnection     = "Connection: ";
	String ^strConnectionData = "Keep-Alive";
	srtlAttr->Add( strConnection,     strConnectionData );
	delete strConnection;
	delete strConnectionData;




	if ( HttpRcvInf->RequestType
		== HttpRcvInf->REQUESTType_GET ) {
		/* t@Ĉ܂ܕԐM */

		String		^strFileName = gcnew String( m_strHttpDir );





		/* ŏ肭sȁEEE */
		if ( HttpRcvInf->GET_FileName == "/" ) {
			strFileName = String::Concat( strFileName, "\\",  m_strHttp_DefaultFile );		
		} else {

			strFileName = gcnew String ( HttpRcvInf->GET_FileName );

			/* /:UpDir/  /../ ɒu */
			String		^strFileNameTmp
				= strFileName->Replace( "/:UpDir/", "/../" );
			String		^strFileNameTmp2
				= strFileNameTmp->Replace( "/:UpDir/", "/../" );
			delete strFileName;
			delete strFileNameTmp;
			strFileName = strFileNameTmp2;



			strFileName = strFileName->Replace( '/', '\\' );
			strFileName = String::Concat( m_strHttpDir, strFileName );


			for ( int nContentCnt = 0 ; nContentCnt < 16 ; nContentCnt++ ) {

				bool blHit = false;

				String ^strDiffExt = nullptr;
				String ^strContentTypeData = nullptr;
				switch ( nContentCnt ) {
				case 0:		strDiffExt = "jpg";
							strContentTypeData = " image/jpeg";
							break;
				case 1:		strDiffExt = "jpeg";
							strContentTypeData = " image/jpeg";
							break;
				case 2:		strDiffExt = "lzh";
							strContentTypeData = " application/x-lzh-compressed";
							break;
				case 3:		strDiffExt = "zip";
							strContentTypeData = " application/zip";
							break;
				case 4:		strDiffExt = "gif";
							strContentTypeData = " image/gif";
							break;
				case 5:		strDiffExt = "htm";
							strContentTypeData = " text/html";
							break;
				case 6:		strDiffExt = "html";
							strContentTypeData = " text/html";
							break;
				case 7:		strDiffExt = "txt";
							strContentTypeData = " plain/text";
							break;


				case 8:		strDiffExt = "3gp";
							strContentTypeData = " audio/3gpp";
							//strContentTypeData = " application/x-dcm-fullmusic";
							break;
				case 9:		strDiffExt = "jam";
							strContentTypeData = " application/x-jam";
							break;
				case 10:	strDiffExt = "css";
							strContentTypeData = " text/css";
							break;

				case 11:	strDiffExt = "mp4";
							strContentTypeData = " video/mp4";
							//strContentTypeData = " video/3gpp2";
							break;

				case 12:	strDiffExt = "wmv";
							strContentTypeData = " video/x-ms-wmv";
							//strContentTypeData = " video/3gpp2";
							break;

				case 13:	strDiffExt = "mpg";
							strContentTypeData = " video/mpeg";
							//strContentTypeData = " video/3gpp2";
							break;

				case 14:	strDiffExt = "mpeg";
							strContentTypeData = " video/mpeg";
							//strContentTypeData = " video/3gpp2";
							break;

				case 15:	strDiffExt = "wav";
							strContentTypeData = " audio/x-wav";
							//strContentTypeData = " video/3gpp2";
							break;

				}

				/* gq jpeg/jpg ̏ꍇ */
				/* image/jpeg ɕύX */
				String ^strExt = strFileName->Substring( strFileName->Length - strDiffExt->Length, strDiffExt->Length );
				strExt = strExt->ToLower();
				if ( strExt == strDiffExt ) {
					blHit = true;
				}

				if ( blHit == true ) {
					String ^strContentType     = gcnew String( "Content-Type: " );
					strContentTypeData = gcnew String( strContentTypeData );

					String ^strBuf = static_cast<String^>
						( srtlAttr[ strContentType ] );
					delete strBuf;

					srtlAttr[ strContentType ] = strContentTypeData;


					break;
				}


			}


		}

	

		/* t@Cǂݍ */
		System::IO::File^	srFile = nullptr;


		try {
			System::IO::FileInfo	^fileinf
				= gcnew System::IO::FileInfo( strFileName );

			if ( fileinf->Length >= 157286400 ) {
				/* 150MB 𒴂t@C͓]Ȃ */
				/* mhttp ̍\AݑMfIɍs@\Ȃ߁B */
				delete fileinf;
				throw( gcnew System::Exception );
			}
			delete fileinf;

			byarContents = srFile->ReadAllBytes( strFileName );
		} catch( System::Exception ^e ) {
			if ( e->GetType() == e->GetType() ) {
				/* File not found Ԃׂ */
				blErr = true;


				strAckStr = "HTTP/1.1 404 NG";

				byarContents = System::Text::Encoding::ASCII->GetBytes(
									"\r\n"
									"File not found\r\n"
									);

			}
			delete e;
		}
		delete srFile;

		if ( !blErr ) {
			strAckStr = gcnew String ( "HTTP/1.1 200 OK" );
		}
		




		/* t@CMɓrMvꍇ */
		String ^strKeyRange = gcnew String( "Range:" );
		if ( HttpRcvInf->m_srtAttr->ContainsKey( strKeyRange ) ) {

			String ^strData
				= static_cast<String^>( HttpRcvInf->m_srtAttr[ strKeyRange ] );


			if ( strData->IndexOf( " bytes=" ) >= 0 ) {
				String ^strDataEdit = strData->Substring( 7 );
				delete strData;
				strData = strDataEdit;
			}

			int nMinus = strData->IndexOf( "-" );
			if ( nMinus >= 0 ) {
				String ^strPosTop
					= strData->Substring( 0, nMinus );

				String ^strPosEnd
					= strData->Substring( nMinus + 1 );

				
				int nPosTop = -1;
				int nPosEnd = -1;

				try {
					nPosTop = System::Convert::ToInt32( strPosTop );
				} catch ( System::Exception ^e ) {
					nPosTop = -1;
					delete e;
					m_pLogP->LogWithDate( "http: Range wb_ϊ~X" );
				}

				try {
					nPosEnd = System::Convert::ToInt32( strPosEnd );

				} catch ( System::Exception ^e ) {
					nPosEnd = byarContents->Length - 1;
					delete e;
					//m_pLogP->LogWithDate( "http: Range wb_ϊ~X" );
				}


				if ( nPosTop != -1 && nPosEnd != -1 ) {


					array<Byte>	^byarContentsTemp
						= gcnew array<Byte>( nPosEnd - nPosTop + 1 );

					array<Byte>::Copy( byarContents, nPosTop,
									   byarContentsTemp, 0 , nPosEnd - nPosTop + 1 );
					delete byarContents;

					byarContents = byarContentsTemp;


					delete strAckStr;
					strAckStr = gcnew String ( "HTTP/1.1 206 Partial content" );




					/* Last-Modified: Wed, 05 Sep 2001 06:02:09 GMT */
					String ^strLastModefied     = "Last-Modified: ";

					System::IO::FileInfo	^pFileInf
						= gcnew System::IO::FileInfo( strFileName );
					System::DateTime FileDateTime = pFileInf->LastWriteTimeUtc;
					String ^strLastModefiedData = FileDateTime.ToString("R");
					delete pFileInf;

					srtlAttr->Add( strLastModefied, 
								   strLastModefiedData );
					delete strLastModefied;
					delete strLastModefiedData;




					/* Pragma: no-cache */
					String ^strPragma     = "Pragma: ";
					String ^strPragmaData = "no-cache";
					srtlAttr->Add( strPragma, 
								   strPragmaData );
					delete strPragma;
					delete strPragmaData;



					/* Accept-Ranges: bytes */
					String ^strAcceptRanges      = "Accept-Ranges: ";
					String ^strAcceptRangesData  = "bytes";
					srtlAttr->Add( strAcceptRanges, 
								   strAcceptRangesData );
					delete strAcceptRanges;
					delete strAcceptRangesData;




					/* Content-range: bytes 1001-1325/1326 */
					String ^strContentRange      = "Content-range: ";
					String ^strContentRangeData  = 
						String::Format( "bytes {0}-{1}/{2}",
									nPosTop,
									nPosEnd,
									nPosEnd - nPosTop + 1 );
					srtlAttr->Add( strContentRange, 
								   strContentRangeData );
					delete strContentRange;
					delete strContentRangeData;

				}

			}
			
				
		}

		delete strKeyRange;



		delete strFileName;
			
	}
	else if ( HttpRcvInf->RequestType == HttpRcvInf->REQUESTType_POST ) {

		/* mhttp Ǝ̎ */
		HttpPostAck		^pHttpPostAck = gcnew HttpPostAck();

		pHttpPostAck->m_HttpRequestData = HttpRcvInf;

		byarContents = pHttpPostAck->ExecutePost();

		if ( byarContents == nullptr ) {
			byarContents = gcnew array<Byte>( 0 );
		}

		delete pHttpPostAck;


		strAckStr = gcnew String ( "HTTP/1.1 200 OK" );




	} else {

		/* T|[g̃\bh */
		strAckStr = "HTTP/1.1 404 NG";

		byarContents = System::Text::Encoding::ASCII->GetBytes(
							"\r\n"
							"File not found\r\n"
							);

	}




	/* Content-Length Đݒ */
	String ^strContentsLength =
			gcnew String( "Content-Length: " );

	String ^strContentsLengthData =
		gcnew String( System::Convert::ToString(byarContents->Length ) );


	srtlAttr[ strContentsLength ] = strContentsLengthData;

	delete strContentsLength;
	delete strContentsLengthData;




	/*******************************************/
	/* ԐMe쐬 */
	/*******************************************/
	int		nSendSize = 0;
	int		nAckSize = 0;
	int		nContentsSize = 0;
	int		nAttrSize = 0;

	nAckSize = strAckStr->Length + 2;
	nSendSize += nAckSize;


	/* TCY */
	for ( int nCnt = 0 ; nCnt < srtlAttr->Count ; nCnt++ ) {

		String ^strAttrLine
			= String::Concat( 
				static_cast<String^>( srtlAttr->GetKey( nCnt )   ), 
				static_cast<String^>( srtlAttr->GetByIndex( nCnt ) )
				);

		nAttrSize += System::Text::Encoding::ASCII->GetBytes( strAttrLine )->Length + 2;

		delete strAttrLine;
	}
	nSendSize += nAttrSize;


	/* RecTCY */
	nSendSize += 2;
	nSendSize += byarContents->Length;












	/* ԐMzɍ쐬 */
	if ( byarSend != nullptr ) 
		delete byarSend;
	byarSend = gcnew array<Byte>( nSendSize );
	
	int		nArrayPtr = 0;
	
	/* R}h */
	array<Byte>		^byarAckStr
		= System::Text::Encoding::ASCII->GetBytes( strAckStr );

	array<Byte>::Copy( 
		byarAckStr,
		byarSend,
        nAckSize-2 );
	byarSend[ nAckSize-2 ] = '\r';
	byarSend[ nAckSize-1 ] = '\n';

	nArrayPtr += nAckSize;


	delete	strAckStr;
	delete byarAckStr;


	/*  */
	for ( int nCnt = 0 ; nCnt < srtlAttr->Count; nCnt++ ) {

		
		String ^strAttrLine
			= String::Concat( 
				static_cast<String^>( srtlAttr->GetKey( nCnt ) ), 
				static_cast<String^>( srtlAttr->GetByIndex( nCnt ) )
				);

		array<Byte>		^byarAttrLine
			 = System::Text::Encoding::ASCII->GetBytes( strAttrLine );

		array<Byte>::Copy(
				byarAttrLine,
				0,
				byarSend, 
				nArrayPtr, 
				byarAttrLine->Length );


		nArrayPtr += byarAttrLine->Length;

		byarSend[ nArrayPtr ] = '\r';
		byarSend[ nArrayPtr+1 ] = '\n';

		nArrayPtr += 2;


		delete strAttrLine;
		delete byarAttrLine;
	}


	byarSend[ nArrayPtr ] = '\r';
	byarSend[ nArrayPtr+1 ] = '\n';
	nArrayPtr += 2;

	delete	srtlAttr;



	/* contents */
	array<Byte>::Copy(
		byarContents,
		0,
		byarSend, 
		nArrayPtr, 
		byarContents->Length );
	nArrayPtr += byarContents->Length;


	delete byarContents;




	blRet = true;
	return blRet;
}



void nsSvcMHttp::MakeHttpRetData::OutputLog( 
	nsSvcMHttp::HttpRequestData ^HttpRcvInf )
{

	String		^strLogStr;

	/* ڑ IP AhX */
	strLogStr = String::Concat(
		"Client-IP:", HttpRcvInf->ClientIp );

	/* Client-IP:xxx.xxx.xxx.xxx  */
	while ( strLogStr->Length < 30  ) {
		strLogStr = String::Concat( strLogStr, " " );
	}



	/* NGXg^Cv  GET/POST/CGI */
	String		^strBuf;
	switch( HttpRcvInf->RequestType )
	{
	case HttpRcvInf->REQUESTType_GET:
		strBuf = String::Concat( "GET---",
								 HttpRcvInf->GET_FileName );
		break;
	case HttpRcvInf->REQUESTType_POST:	
		strBuf = gcnew String( "POST " );		
		break;
	case HttpRcvInf->REQUESTType_CGI:
		strBuf = String::Concat( 
							"CGI  ",
							HttpRcvInf->CGI_Arg
							);
		break;
	}

	while( strBuf->Length < 30 ) {
		strBuf = String::Concat( strBuf, " " );
	}

	strLogStr = String::Concat( 
		strLogStr, "REQUEST-TYPE : ", strBuf, "  " );

	delete strBuf;


	






	/* [ŨNCAg */
	switch( HttpRcvInf->UserAppType )
	{
	case HttpRcvInf->USERAPPTYPE_PC:	
		strBuf = gcnew String( "PC     " );
		break;
	case HttpRcvInf->USERAPPTYPE_DOCOMO:
		strBuf = gcnew String( "DOCOMO " );
		break;
	case HttpRcvInf->USERAPPTYPE_ELSE:
		strBuf = gcnew String( "ELSE   " );
		break;
	}

	strLogStr = String::Concat( 
		strLogStr, "CLIENT-TYPE : ", strBuf );

	delete strBuf;


	strLogStr = String::Concat( strLogStr, "           ATTRS   :   " );
	for ( int nCnt = 0; nCnt < HttpRcvInf->m_srtAttr->Count; nCnt++ ) {

		String ^strKey = static_cast<String^>( 
			HttpRcvInf->m_srtAttr->GetKey( nCnt ) );

		strLogStr = String::Concat( 
						strLogStr, " ",
						strKey , 
						static_cast<String^>( HttpRcvInf->m_srtAttr[ strKey ] )
					);

	}


	strLogStr = String::Concat( "httpd : ", strLogStr );

	m_pLogP->LogWithDate( strLogStr );
	MHttpTray	^pMHttpTray	= gcnew MHttpTray();
	pMHttpTray->AddMessage( strLogStr );
	delete pMHttpTray;

	delete strLogStr;
}







