#pragma once

#include "ThrMHttp.h"
#include "etc\LogPlus.h"
#include "SvcNameDef.h"



/* [Q]- System.ServiceProcess.dll */
using namespace System;


namespace nsSvcMHttp
{
	using namespace System::ServiceProcess;


	public ref class SvcMHttp : public System::ServiceProcess::ServiceBase
	{

	public:
		SvcMHttp(void)
		{
			this->ServiceName = SVCNAMEDEF_SERVICENAME;
			this->CanStop = true;
			this->CanPauseAndContinue = false;
			this->AutoLog = false;


			m_ThrMHttp = nullptr;

			m_pLogP = gcnew nsSvcMHttp::LogP();
			m_pLogP->StartLogP();
			m_pLogP->Open();


			if ( RetDebugOutFlg() == true ) {
				m_pLogP->OpenNameOF( 0, "debug.txt" );
			}


		}

		~SvcMHttp(void)
		{
			m_pLogP->Close();
			m_pLogP->ExitLogP();
			delete m_pLogP;
			m_pLogP = nullptr;
		}


	public:
		virtual void OnStart( array<System::String ^>^ args ) override
		{
			m_pLogP->LogWithDate( "T[rXJn" );			
			
			if ( m_ThrMHttp == nullptr ) {
				m_ThrMHttp = gcnew ThrMHttp();
			}
			m_ThrMHttp->BeginTcpThread();

			return;
		}


		virtual void OnStop() override
		{
			m_ThrMHttp->ExitTcpThread();
			delete m_ThrMHttp;

			m_pLogP->LogWithDate( "T[rXI" );			
		}






		ThrMHttp			^m_ThrMHttp;
		nsSvcMHttp::LogP	^m_pLogP;

	private:
		bool	RetDebugOutFlg( void );

	};

}