#pragma once

#include "MiniHttp\MiniHttp.h"
#include "MiniHttp\MHttpTray.h"

#include "etc\SyslogD.h"
#include "etc\GetIPBrs\GetIPBrs.h"

#include "Mail\MailManage.h"


/* [Q]- System.ServiceProcess.dll */
using namespace System;


namespace nsSvcMHttp
{
	using namespace System::Threading;


	public ref class ThrMHttp
	{

	public:
		ThrMHttp(void)
		{	
			m_pMiniHttp = nullptr;
			m_pSyslogd = nullptr;
			m_pMailReactor = nullptr;
			m_pMHttpTray = nullptr;
			m_pIPGetBrowse = nullptr;

			m_ExitThreadFromInternal = false;
		}

	public:

#pragma region void BeginTcpThread( void )
		void BeginTcpThread( void )
		{
			m_pMiniHttp    = gcnew nsSvcMHttp::MiniHttp();
			m_pSyslogd     = gcnew nsSvcMHttp::SysLogD();
			m_pMailReactor = gcnew nsSvcMHttp::MailReactor();
			m_pMHttpTray   = gcnew nsSvcMHttp::MHttpTray();
			m_pIPGetBrowse = gcnew nsSvcMHttp::IPGetBrowse();

			m_TcpThread_Main = gcnew Thread( gcnew ThreadStart( 
				this, &nsSvcMHttp::ThrMHttp::SvcThreadMain )  );
			m_TcpThread_Main->Start();

		}
#pragma endregion

#pragma region void ExitTcpThread( void )
		void ExitTcpThread( void )
		{
			m_ExitThread = true;
			m_TcpThread_Main->Join();

			delete m_pMiniHttp;
			m_pMiniHttp = nullptr;

			delete m_pSyslogd;
			m_pSyslogd = nullptr;

			delete m_pMailReactor;
			m_pMailReactor = nullptr;

			delete m_pMHttpTray;
			m_pMHttpTray = nullptr;

			delete m_pIPGetBrowse;
			m_pIPGetBrowse = nullptr;


		}
#pragma endregion




#pragma region void SvcThreadMain( void )
	public:
		/* ғ̃T[rX̃C[` */
		void SvcThreadMain( void )

		{

			
			m_pMiniHttp->StartMiniHttp();
			m_pSyslogd->StartSysLogD();
			m_pMailReactor->StartMailReactor();
			m_pMHttpTray->StartMHttpTray();
			m_pIPGetBrowse->StartBrowse();

			while ( 1 ) {
				//if ( m_ExitThread ) 
				if ( m_ExitThread || m_ExitThreadFromInternal) 
					break;

				
				m_pMiniHttp->ReactSession();
				m_pSyslogd->ReactSession();
				m_pMailReactor->ReactSession();
				m_pMHttpTray->ReactSession();
				m_pIPGetBrowse->ReactSession();
				System::Threading::Thread::Sleep( 1 );
			}

			m_pMiniHttp->ExitMiniHttp();
			m_pSyslogd->ExitSysLogD();
			m_pMailReactor->ExitMailReactor();
			m_pMHttpTray->ExitMHttpTray();
			m_pIPGetBrowse->ExitBrowse();


		}
#pragma endregion

	public:
		static void StopThreadFromInternal( void ) {
			m_ExitThreadFromInternal = true;
		}



	public: static bool	m_ExitThreadFromInternal;

	private: Thread^ m_TcpThread_Main;
	private: bool		m_ExitThread;

	private:		nsSvcMHttp::MiniHttp		^m_pMiniHttp;

	private:		nsSvcMHttp::MHttpTray		^m_pMHttpTray;

	private:		nsSvcMHttp::SysLogD			^m_pSyslogd;

	private:		nsSvcMHttp::MailReactor		^m_pMailReactor;

	private:		nsSvcMHttp::IPGetBrowse		^m_pIPGetBrowse;

	};

}