#include "StdAfx.h"
#include "GetIPBrs.h"
#include "..\IoIni.h"

nsSvcMHttp::IPGetBrowse::IPGetBrowse(void)
{
	m_s = nullptr;
	m_nState = enmStatus::POLL_WAITSTART;
	m_nError = enmError::NONE;

	m_strIpStr = nullptr;

	m_objSender = gcnew Sender();

	m_byarSnd = nullptr;
	m_byarRcv = nullptr;


	m_blFirstUsePrc300 = IsUsePrs300();


}
nsSvcMHttp::IPGetBrowse::~IPGetBrowse(void)
{
	if ( m_s != nullptr ) {
		if (m_s->Connected)
			m_s->Close();
		delete m_s;
	}
	m_s = nullptr;
	
	if ( m_byarRcv != nullptr ) {
		delete m_byarRcv;
	}
	m_byarRcv = nullptr;

	if ( m_byarSnd != nullptr ) {
		delete m_byarSnd;
	}
	m_byarSnd = nullptr;

	delete m_strIpStr;
}





bool nsSvcMHttp::IPGetBrowse::StartBrowse(void)
{
	if ( m_blFirstUsePrc300 ) {

		if ( m_nState == enmStatus::POLL_WAITSTART || 
			 m_nState == enmStatus::POLL_WAIT ) {
			m_nState = enmStatus::CONNECT;
		}
	}

	return true;
}



void nsSvcMHttp::IPGetBrowse::ReactSession(void)
{

	enmStatus		enmRet;

	/* ^CAEgEEE */

	enmRet = m_nState;
	switch ( enmRet ) {
	case enmStatus::POLL_WAITSTART:
		enmRet = ExeStStartWaitSet();
		break;
	case enmStatus::POLL_WAIT:
		enmRet = ExeStStartWait();
		break;

	case enmStatus::CONNECT:
		/* tcp ڑ  ->  M  ܂ŎԂ󂭂vEEEH */
		enmRet = ExeStConnect();
		break;
		
	case enmStatus::SEND_GET_TOP:
		/* GET html... 𑗐M */
		enmRet = ExeStSendFirst();
		break;

	case enmStatus::SEND_GET_TOP_WAIT:	
		if ( m_objSender->IsSent() == true ) {
			bool blRet;
			blRet = m_objSender->TryRcv( 10000 );
			if ( blRet ) {;
				enmRet = enmStatus::RCV__GET_TOP_WAIT;
			}
		} else {
			if ( m_objSender->IsSendErr() ) {
				/* gC */
				CloseSocket();
				enmRet = enmStatus::CONNECT;
				m_nError = enmError::SEND_GET_TOP_WAIT_SENDTIMEOUT;
			}
		}
		break;

	case enmStatus::RCV__GET_TOP_WAIT:

		if ( m_objSender->IsRcved( m_byarRcv ) == true ) {

			//String ^strBuf;
			//strBuf = System::Text::Encoding::ASCII->GetString( m_byarRcv );

			/* x\Pbg */
			CloseSocket();
			enmRet = enmStatus::RECONNECT;
		} else {
			if ( m_objSender->IsRcvErr() ) {
				/* gC */
				CloseSocket();
				enmRet = enmStatus::CONNECT;
				m_nError = enmError::RCV__GET_TOP_WAIT_RCVTIMEOUT;
			}
		}
		break;
		
	case enmStatus::RECONNECT:
		enmRet = ExeStReConnect();
		break;

	case enmStatus::SEND_GET_BASE64URL:
		enmRet = ExeStSendBase64Url();
		break;

	case enmStatus::SEND_GET_BASE64URL_WAIT:	
		if ( m_objSender->IsSent() == true ) {
			bool blRet;
			m_s->ReceiveTimeout = 500;
			blRet = m_objSender->TryRcv( 300 );
			if ( blRet ) {;
				enmRet = enmStatus::RCV__GET_BASE64URL_HEADER_WAIT;
			}
		} else {
			if ( m_objSender->IsSendErr() ) {
				/* gC */
				CloseSocket();
				enmRet = enmStatus::CONNECT;
				m_nError = enmError::SEND_GET_BASE64URL_WAIT_SNDTIMEOUT;
			}
		}
		break;

	case enmStatus::RCV__GET_BASE64URL_HEADER_WAIT:
		enmRet = ExeStRcvBase64UrlHeader();
		break;

	case enmStatus::RCV__GET_BASE64URL_CONTENTS_WAIT:
		enmRet = ExeStRcvBase64UrlContents();
		break;

	}

	m_nState = enmRet;
	return;
}


nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStStartWaitSet(void)
{
	if ( IsUsePrs300() != true ) {
		return enmStatus::POLL_WAITSTART;
	}

	m_dteKickTime = System::DateTime::Now;
	/* {Ȃ ini t@Cǂݍ݂c */
	m_dteKickTime = m_dteKickTime.AddSeconds( 5 * 60 );
	//m_dteKickTime = m_dteKickTime.AddSeconds( 1 );

	return enmStatus::POLL_WAIT;
}



nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStStartWait(void)
{
	if ( System::DateTime::Compare( m_dteKickTime, DateTime::Now ) < 0 ) {
		return enmStatus::CONNECT;
	}
	return enmStatus::POLL_WAIT;
}


nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStConnect(void)
{
	IniInfo		^pIniInfo = gcnew IniInfo();
		
	String ^strModemIp = gcnew String( "ntt.setup" );
	pIniInfo->ReadIni( IniInfo::KeyTable::STR_PRS300MODEM_IPADDRESS, 
					strModemIp );
	delete pIniInfo;


	m_s = CreateSocket( strModemIp );
	delete strModemIp;
	if ( m_s == nullptr ) {
		m_nError = enmError::CONNECT_FAILED;
		return enmStatus::POLL_WAITSTART;
	}
	m_s->ReceiveTimeout = 500;
	m_objSender->SetSocket( m_s );

	return enmStatus::SEND_GET_TOP;
}




nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStSendFirst(void)
{

	array<Byte>	^byarSnd;
	
	byarSnd = System::Text::Encoding::ASCII->GetBytes( 
		
		"GET / HTTP/1.1\r\n"
		"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shock"
		"wave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application"
		"/msword, */*\r\n"
		"Accept-Language: ja\r\n"
		"Accept-Encoding: gzip, deflate\r\n"
		"User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0"
		".50727)\r\n"
		"Host: localhost\r\n"
		"\r\nConnection: Keep-Alive\r\n"
		"\r\n"
		"\r\n"

	);
	
	bool blRet;
	blRet = m_objSender->TrySend( byarSnd );
	delete byarSnd;	
	if ( blRet ) {
		return enmStatus::SEND_GET_TOP_WAIT;
	} else {
		return enmStatus::SEND_GET_TOP;
	}
}





nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStReConnect(void)
{
	enmStatus	enmRet;
	enmRet = ExeStConnect();

	if ( enmRet != enmStatus::SEND_GET_TOP ) {
		m_nError = enmError::RECONNECT_FAILED;
		return enmStatus::POLL_WAIT;
	}
	return enmStatus::SEND_GET_BASE64URL;

}




nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStSendBase64Url(void)
{

	array<Byte>	^byarSnd;
	
	String ^strHttpReq;



	IniInfo		^pIniInfo = gcnew IniInfo();
		
	String ^strUseName = gcnew String( "user" );
	String ^strPasswd  = gcnew String( "password" );
	
	pIniInfo->ReadIni( IniInfo::KeyTable::STR_PRS300MODEM_USERNAME, strUseName );
	pIniInfo->ReadIni( IniInfo::KeyTable::STR_PRS300MODEM_PASSWORD, strPasswd );
	delete pIniInfo;

	String ^strUserPas
		= String::Concat( strUseName, ":", strPasswd );

	array<Byte>	^byarBase64;
	//byarBase64 = System::Text::Encoding::ASCII->GetBytes( "user:gekigans" );
	byarBase64 = System::Text::Encoding::ASCII->GetBytes( strUserPas );
	delete strUserPas;
	
	strHttpReq = String::Concat( "GET /index.cgi/info_main HTTP/1.1\r\n"
		"Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shock"
		"wave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application"
		"/msword, */*\r\n"
		"Accept-Language: ja\r\n"
		"Authorization: Basic ", System::Convert::ToBase64String( byarBase64 ), "\r\n" );


	strHttpReq = String::Concat( strHttpReq, 
		"Accept-Encoding: gzip, deflate\r\n"
		"User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0"
		".50727)\r\n"
		"Host: localhost\r\n"
		"\r\nConnection: Keep-Alive\r\n"
		"\r\n"
		"\r\n"
		);

	delete byarBase64;


	byarSnd = System::Text::Encoding::ASCII->GetBytes( strHttpReq );
		
	
	
	bool blRet;
	blRet = m_objSender->TrySend( byarSnd );
	delete byarSnd;	
	if ( blRet ) {
		return enmStatus::SEND_GET_BASE64URL_WAIT;
	} else {
		return enmStatus::SEND_GET_BASE64URL;
	}
}




nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStRcvBase64UrlHeader(void)
{
	if ( m_objSender->IsRcved( m_byarRcv ) == false ) {
		return enmStatus::RCV__GET_BASE64URL_HEADER_WAIT;
	} else {
		if ( m_objSender->IsRcvErr() ) {
			/* gC */
			CloseSocket();
			m_nError = enmError::RCV__GET_BASE64URL_HEADER_WAIT_RCVTIMEOUT;
			return enmStatus::CONNECT;
		}
	}

	String ^strRcv
		= System::Text::Encoding::ASCII->GetString( m_byarRcv );

	int nIndex, nIndexEnd;
	nIndex = strRcv->IndexOf( "Content-Length: " );
	if ( nIndex > 0 ) {
		nIndexEnd = strRcv->IndexOf( "\r\n", nIndex + 16 );
	}
	if ( nIndex < 0 || nIndexEnd < 0) {
		/* ȂBG[ŏI */
		CloseSocket();
		m_nError = enmError::RCV__GET_BASE64URL_HEADER_WAIT_NO_CONTENTS_LENGTH;
		return enmStatus::POLL_WAITSTART;
	}

	nIndex += 16;
	int	nContentLength;
	String ^strLength
				= strRcv->Substring( nIndex, nIndexEnd - 1 - nIndex + 1 );

	if ( Int32::TryParse( strLength, nContentLength ) == false ) {
		/* ƂȂBG[ŏI */
		CloseSocket();
		m_nError = enmError::RCV__GET_BASE64URL_HEADER_WAIT_BAD_CONTENTS_LENGTH;
		return enmStatus::POLL_WAITSTART;
	}
	delete strRcv;
	delete strLength;




	// Mς݂͑OB
	// RecTCYǂׂEEEB
	m_objSender->TryRcvAppendFull( nContentLength  );
	return enmStatus::RCV__GET_BASE64URL_CONTENTS_WAIT;

}



nsSvcMHttp::IPGetBrowse::enmStatus nsSvcMHttp::IPGetBrowse::ExeStRcvBase64UrlContents(void)
{

	if ( m_objSender->IsRcved( m_byarRcv ) == false ) {
		return enmStatus::RCV__GET_BASE64URL_CONTENTS_WAIT;
	} else {
		if ( m_objSender->IsRcvErr() ) {
			/* gC */
			CloseSocket();
			m_nError = enmError::RCV__GET_BASE64URL_CONTENTS_WAIT_RCVTIMEOUT;
			return enmStatus::CONNECT;
		}
	}


	String ^strRcv;

	//strRcv = System::Text::Encoding::GetEncoding( "iso-2022-jp" )->GetString( m_byarRcv );
	strRcv = System::Text::Encoding::GetEncoding( "EUC-jp" )->GetString( m_byarRcv );

	CloseSocket();



	int nStart = 0;
	String ^strKey = "WANIPAhX\܂";

	bool blFind = false;
	System::Net::IPAddress	^addr = gcnew System::Net::IPAddress(0 );
	
	while ( blFind == false && nStart < strRcv->Length ) {
		int nSta;
		nSta = strRcv->IndexOf( strKey, nStart );
		if ( nSta < 0 ) {
			break;
		}

		String ^strSearch
			= strRcv->Substring( nSta + 16 , 150 );
		
		// IP AhX̗LT[`

		bool blExit = false;
		while ( 1 ) {
			int nSta2;
			nSta2 = strSearch->IndexOf( '>' );
			if ( nSta2 >= 0 ) {
				strSearch = strSearch->Substring( nSta2 + 1 );
			} else {
				blExit = true;
			}

			int nEnd2;
			nEnd2 = strSearch->IndexOf( '<' );
			if ( nEnd2 >=3 ) {
				String ^strSearchCut;
				strSearchCut = strSearch->Substring( 0, nEnd2  );
				if ( System::Net::IPAddress::TryParse( strSearchCut, addr ) ) {
					blFind = true;
					delete strSearchCut;
					break;
				}
				delete strSearchCut;
			}

			if ( blExit ) {
				break;
			}

		}
		nStart = nSta + 16 + 150;

		if ( blFind ) {
			delete strSearch;
		}

	}

	delete strKey;
	delete strRcv;

	m_strIpStr = addr->ToString();
	delete addr;




	return enmStatus::POLL_WAITSTART;
}







bool nsSvcMHttp::IPGetBrowse::UseFirstPrs300(void)
{
	return m_blFirstUsePrc300;
}

bool nsSvcMHttp::IPGetBrowse::IpGot(void)
{
	return ( m_strIpStr != nullptr);
}


bool nsSvcMHttp::IPGetBrowse::IsUsePrs300(void)
{
	IniInfo		^pIniInfo = gcnew IniInfo();
		
	String ^strUsrPrs300 = gcnew String( "false" );
		pIniInfo->ReadIni( IniInfo::KeyTable::STR_PRS300MODEM_USEPOLLING, 
					strUsrPrs300 );

	bool blRet;

	strUsrPrs300 = strUsrPrs300->ToLower();
	if ( strUsrPrs300 == "true" ) {
		blRet = true;
	} else {
		blRet = false;
	}
	delete pIniInfo;
	delete strUsrPrs300;

	return blRet;
}


System::Net::Sockets::Socket^ nsSvcMHttp::IPGetBrowse::CreateSocket( System::String ^strHostName )
{

	
	System::Net::Sockets::Socket		^s_ret = nullptr;
	String								^strHostString;
	Int32								^int32Port = nullptr;


	strHostString = String::Copy( strHostName );
	
	System::Net::IPHostEntry^ hostEntry = nullptr;
	try {
		hostEntry = System::Net::Dns::GetHostEntry( strHostString );
	} catch ( Exception ^e ) {
		delete e;
		delete strHostString;
		return s_ret;
	}

	//int32Port = gcnew Int32( 8081 );
	int32Port = gcnew Int32( 80 );


	//delete HostString;

	//hostEntry = Dns::GetHostEntry( "127.0.0.1" );
	//hostEntry = Dns::GetHostEntry( "192.168.33.194" );
	//hostEntry = Dns::GetHostEntry( strHostString );


	
	System::Net::IPAddress^			address = nullptr;
	System::Net::IPEndPoint^		endPoint = nullptr;
	System::Net::Sockets::Socket^	tmpS = nullptr;


	System::Collections::IEnumerator^ myEnum = hostEntry->AddressList->GetEnumerator();
	while ( myEnum->MoveNext() )
	{
		address  = safe_cast<System::Net::IPAddress^>(myEnum->Current);
		endPoint = gcnew System::Net::IPEndPoint( address, (int)int32Port );
		tmpS     = gcnew System::Net::Sockets::Socket( 
							endPoint->AddressFamily, 
							System::Net::Sockets::SocketType::Stream,
							System::Net::Sockets::ProtocolType::Tcp );

		


		try {

			tmpS->Connect( endPoint );

		} catch ( Exception^ e ) {

			delete strHostString;
			delete int32Port;

			delete address;
			delete endPoint;
			delete tmpS;
			delete e;
			//return s_ret;

		}

		if ( tmpS->Connected )
		{
			/* zXgA|[g\Pbg擾 */
			s_ret = tmpS;
			break;
		} else {
			delete address;
			delete endPoint;
			delete tmpS;
			continue;
		}

	}

	if ( s_ret == nullptr ) {
		/* \Pbg̐ڑs */

		delete strHostString;
		delete int32Port;

		delete address;
		delete endPoint;
		delete tmpS;

		return s_ret;
	}

	int		nTimeOut = 1000;
	s_ret->ReceiveTimeout = nTimeOut;



	delete strHostString;
	delete int32Port;
	delete address;
	delete endPoint;



	return s_ret;
}




void nsSvcMHttp::IPGetBrowse::CloseSocket(void )
{

#if 0
	System::IAsyncResult ^result;
	m_s->EndReceive( result );
	delete result;
#endif
	if ( m_s == nullptr ) 
		return;

	if ( m_s->Connected ) {
		m_s->Disconnect( false );
	}
	m_s->Close();

	m_s = nullptr;
}