#include "StdAfx.h"
#include "GetIPBrs.h"


nsSvcMHttp::IPGetBrowse::Sender::Sender( void ) 
{
	m_nSendState = enmSendStatus::NONE;

	m_nRcvState = enmRcvStatus::NONE;

	
	m_evSend = gcnew System::Net::Sockets::SocketAsyncEventArgs;
	m_evRcv  = gcnew System::Net::Sockets::SocketAsyncEventArgs;


	m_evSend->Completed +=
		gcnew System::EventHandler<System::Net::Sockets::SocketAsyncEventArgs ^>( 
		this, &nsSvcMHttp::IPGetBrowse::Sender::SendCompleteEvent );
#if 0
	m_evRcv->Completed +=
		gcnew System::EventHandler<System::Net::Sockets::SocketAsyncEventArgs ^>( 
		this, &nsSvcMHttp::IPGetBrowse::Sender::RcvCompleteEvent );
#endif

	m_evRcv->UserToken = this;

	m_dltRcvCallBack = nullptr;

	m_blRcvFullMode = false;
}




nsSvcMHttp::IPGetBrowse::Sender::~Sender( void ) 
{
	
	bool		blTimeOut = true;
	DateTime	dteEnd;
	/* MI܂ő҂ */
	
	dteEnd = DateTime::Now.AddMilliseconds( 500 );

	while ( DateTime::Compare( DateTime::Now, dteEnd ) > 0 ) {


		if ( m_nSendState == enmSendStatus::SENDING ) {
			// Cxg҂ DoEvent ̊֐Ăтc
			continue;
		}
		blTimeOut = false;
		break;
	}


	/* IɃN[Y */
	delete m_evSend->Completed;
	if ( m_evSend->BufferList != nullptr ) {
		/* KɃobt@Ăw */
		delete m_evSend->BufferList;
	}	
	delete m_evSend;

	if ( m_byarSendData != nullptr ) {
		delete m_byarSendData;
		m_byarSendData = nullptr;
	}
	m_evSend = nullptr;


	delete m_evRcv->Completed;
	if ( m_evRcv->BufferList != nullptr ) {
		/* KɃobt@Ăw */
		delete m_evRcv->BufferList;
	}	
	delete m_evSend;

	if ( m_byarRcvData != nullptr ) {
		delete m_byarRcvData;
		m_byarRcvData = nullptr;
	}
	m_evRcv = nullptr;




	if ( m_dltRcvCallBack != nullptr ) {
		delete m_dltRcvCallBack;
	}
}




void nsSvcMHttp::IPGetBrowse::Sender::SetSocket( System::Net::Sockets::Socket ^%socket )
{
	m_scKocket = socket;
}
System::Net::Sockets::Socket^% nsSvcMHttp::IPGetBrowse::Sender::GetSocket( void )
{
	return m_scKocket;
}



bool nsSvcMHttp::IPGetBrowse::Sender::IsSent( void )
{
	if ( m_nSendState == enmSendStatus::SENDING ) {
		return false;
	} else {
		return true;
	}
}

bool nsSvcMHttp::IPGetBrowse::Sender::IsRcved( array<System::Byte> ^%byarRcv )
{
	if ( m_nRcvState == enmRcvStatus::RCVING ) {

		if ( DateTime::Compare( m_dteRcvTimeOut, DateTime::Now ) < 0 ) {
			m_nRcvState = enmRcvStatus::RCV_ERR;
		}

		return false;
	} else {

		if ( byarRcv == nullptr ) {
			byarRcv = gcnew array<Byte>( m_byarRcvData->Length );
		} else {
			array<Byte>::Resize(byarRcv, m_byarRcvData->Length );
		}

		array<Byte>::Copy( m_byarRcvData, byarRcv, m_byarRcvData->Length );

		return true;
	}
}



bool nsSvcMHttp::IPGetBrowse::Sender::IsSendErr( void )
{
	return ( m_nSendState == enmSendStatus::SEND_ERR);
}
bool nsSvcMHttp::IPGetBrowse::Sender::IsRcvErr( void )
{
	return ( m_nRcvState == enmRcvStatus::RCV_ERR);
}

void nsSvcMHttp::IPGetBrowse::Sender::SetRcved( bool blError )
{
	if ( !blError ) {
		m_nRcvState = enmRcvStatus::RCVED;
	} else {
		m_nRcvState = enmRcvStatus::RCV_ERR;
	}

}


bool nsSvcMHttp::IPGetBrowse::Sender::TrySend( array<System::Byte> ^%byarData ) 
{

	if ( m_nSendState == enmSendStatus::SENDING ) {
		return false;
	}

	if ( m_byarSendData != nullptr ) {
		delete m_byarSendData;
	}

	int nSize = byarData->Length;
	m_byarSendData = gcnew array<Byte>( nSize );
	array<Byte>::Copy( byarData, m_byarSendData, nSize );


	m_evSend->SetBuffer( m_byarSendData, 0, nSize  );

	bool blRet;

	m_nSendState = enmSendStatus::SENDING;
	m_dteSndTimeOut = DateTime::Now.AddMilliseconds( 500 );

	blRet = m_scKocket->SendAsync( m_evSend );

	if ( blRet == false ) {
		m_nSendState = enmSendStatus::SENDED;
	}

	return true;

}




void nsSvcMHttp::IPGetBrowse::Sender::SendCompleteEvent( System::Object^  sender, System::Net::Sockets::SocketAsyncEventArgs^  e)
{
	m_nSendState = enmSendStatus::SENDED;
}



bool nsSvcMHttp::IPGetBrowse::Sender::TryRcv( int nSize ) 
{
	if ( m_nRcvState == enmRcvStatus::RCVING ) {
		return false;
	}

	if ( m_byarRcvData != nullptr ) {
		delete m_byarRcvData;
	}
	m_byarRcvData = gcnew array<Byte>( nSize );

	
	//m_evRcv->SetBuffer( m_byarRcvData, 0, nSize );
	//m_evRcv->SetBuffer( m_byarRcvData, 0, nSize / 2 );
	//m_evRcv->Count = nSize /2;

	//m_evRcv->RemoteEndPoint =  m_scKocket->RemoteEndPoint;
	//m_evRcv->AcceptSocket = m_scKocket;



	if ( m_dltRcvCallBack == nullptr ) {
		m_dltRcvCallBack = gcnew System::AsyncCallback( &nsSvcMHttp::IPGetBrowse::Sender::RcvCompleteEvent );
	}
	m_dteRcvTimeOut = DateTime::Now;
	//m_dteRcvTimeOut = m_dteRcvTimeOut.AddMilliseconds( 2000 );
	m_dteRcvTimeOut = m_dteRcvTimeOut.AddSeconds( 5 );

	m_nRcvCount = 0;
	m_nRcvState = enmRcvStatus::RCVING;
	m_blRcvFullMode = false;


	/* m_nRcvState mɏ܂ */
	System::Threading::Thread::Sleep( 0 );

	m_scKocket->BeginReceive( m_byarRcvData, 0, nSize,
				System::Net::Sockets::SocketFlags::None,
			m_dltRcvCallBack, this );
#if 0
	blRet = m_scKocket->ReceiveAsync( m_evRcv );
	if ( blRet == false ) {
		m_nRcvState = enmRcvStatus::RCVED;
	}
#endif

	return true;

}


bool nsSvcMHttp::IPGetBrowse::Sender::TryRcvAppendFull( int nAddSize ) 
{
	if ( m_nRcvState == enmRcvStatus::RCVING ) {
		return false;
	}

	array<Byte>		^byarNewRcv
		= gcnew array<Byte>( m_nRcvCount + nAddSize );
	array<Byte>::Copy( m_byarRcvData, byarNewRcv, m_nRcvCount );

	delete m_byarRcvData;

	m_byarRcvData = byarNewRcv;


	if ( m_dltRcvCallBack == nullptr ) {
		m_dltRcvCallBack = gcnew System::AsyncCallback( &nsSvcMHttp::IPGetBrowse::Sender::RcvCompleteEvent );
	}
	m_nRcvState = enmRcvStatus::RCVING;
	m_blRcvFullMode = true;

	m_dteRcvTimeOut = DateTime::Now.AddSeconds( 5 );

	/* m_nRcvState mɏ܂ */
	System::Threading::Thread::Sleep( 0 );

	m_scKocket->BeginReceive( m_byarRcvData, m_nRcvCount,nAddSize,
				System::Net::Sockets::SocketFlags::None,
			m_dltRcvCallBack, this );


	return true;

}



void nsSvcMHttp::IPGetBrowse::Sender::TryRcvMore( void ) 
{
	m_scKocket->BeginReceive( m_byarRcvData, 
				m_nRcvCount, m_byarRcvData->Length - m_nRcvCount,
			System::Net::Sockets::SocketFlags::None,
		m_dltRcvCallBack, this );
}

bool nsSvcMHttp::IPGetBrowse::Sender::RcvBufFullMode( void ) 
{
	return m_blRcvFullMode;
}
void nsSvcMHttp::IPGetBrowse::Sender::RcvBufFullMode( bool blMode ) 
{
	m_blRcvFullMode = blMode;
}




int nsSvcMHttp::IPGetBrowse::Sender::RcvCnt::get() {
	return m_nRcvCount;
}
void nsSvcMHttp::IPGetBrowse::Sender::RcvCnt::set( int nSize)
{
	m_nRcvCount = nSize;
}


int nsSvcMHttp::IPGetBrowse::Sender::RcvBufSize::get() {
	return m_byarRcvData->Length;
}


/* ǂRR͕ʃXbhŉғĂ炵BӁIII */
void nsSvcMHttp::IPGetBrowse::Sender::RcvCompleteEvent( System::IAsyncResult ^result)
{
	Sender							^objSender;
	System::Net::Sockets::Socket	^sock;

	objSender = safe_cast<nsSvcMHttp::IPGetBrowse::Sender^>( result->AsyncState );
	sock = safe_cast<System::Net::Sockets::Socket^>( objSender->GetSocket() );

	System::Net::Sockets::SocketError	error;
	

	
	int nReadCnt;
	try {
		/* ȂG[ôŃbvB */
		/* 葤\Pbg؂Ă̂ł͂ȂH */
		nReadCnt = sock->EndReceive( result, error );
	} catch ( System::Exception ^e ) {
		delete e;
		objSender->SetRcved( true );
		return;
	}
	bool blError;

	objSender->RcvCnt += nReadCnt;

	if ( error == System::Net::Sockets::SocketError::Success ) {
		blError = false;
	} else {
		blError = true;
	}
	if ( !objSender->RcvBufFullMode() || blError ) {
		objSender->SetRcved( blError );
		return;
	}

	/* obt@t[h */


	int	nMaxSize = objSender->RcvBufSize;
	if ( objSender->RcvCnt < nMaxSize -1 ) {
		objSender->TryRcvMore();
	} else {
		objSender->SetRcved( false );
		return;
	}
	


}
