#include "stdafx.h"

#include "LogPlus.h"


using namespace System;
using namespace System::Threading;



nsSvcMHttp::LogP::LogP() {
	;
}

nsSvcMHttp::LogP::~LogP() {
	;
}


void nsSvcMHttp::LogP::StartLogP( void )
{
	m_strLogFileName = nullptr;
	m_fsLog = nullptr;
	m_blAutoFileNameChange_Date = true;

	m_objLock = gcnew System::Object();
	m_srtFileList = nullptr;
}

void nsSvcMHttp::LogP::ExitLogP( void )
{
	if ( m_strLogFileName != nullptr)
		delete m_strLogFileName;
	m_strLogFileName = nullptr;

	if ( m_fsLog != nullptr ) {
		m_fsLog->Close();
		delete m_fsLog;
	}
	m_fsLog = nullptr;

	m_blAutoFileNameChange_Date = true;


	if ( m_srtFileList != nullptr ) {
		System::Collections::IList	^illist
			= m_srtFileList->GetKeyList();
		
		for ( int nCnt = 0 ; nCnt < illist->Count ; nCnt++ ) {
			int nKey = static_cast<int>(illist[ nCnt ]);
			delete m_srtFileList[ nKey ];
		}
		delete illist;
		delete m_srtFileList;
		m_srtFileList = nullptr;
	}


	if ( m_objLock != nullptr ) 
		delete m_objLock;
	m_objLock = nullptr;
}



void nsSvcMHttp::LogP::Open( void )
{
	
	m_strLogFileName = MakeFileName();

	if ( m_fsLog ) {
		m_fsLog->Close();
		delete m_fsLog;
	}
	m_fsLog = nullptr;

	m_blAutoFileNameChange_Date = true;

}

void nsSvcMHttp::LogP::OpenName( String ^strLogFileName )
{
	Open();
	if ( m_strLogFileName != nullptr )
		delete m_strLogFileName;
	m_strLogFileName = gcnew String( strLogFileName );
}

void nsSvcMHttp::LogP::OpenNameOF( int nFileNum, String ^strLogFileName )
{

	System::Reflection::Assembly	^myAssembly
		= System::Reflection::Assembly::GetEntryAssembly();
	String	^strPath = myAssembly->Location;

	strPath = strPath->Substring( 0, strPath->LastIndexOf( "\\" ) +1 );
	strPath = String::Concat( strPath, strLogFileName );


	if ( m_srtFileList == nullptr ) {
		m_srtFileList = gcnew System::Collections::SortedList();
	}

	if ( m_srtFileList->ContainsKey( nFileNum ) ) {
		String ^strErrStr;
		strErrStr = "file " + __FILE__ + ",Line " + __LINE__ +
					"F  vOG[Fwς݂̃Ot@Cԍw肵Ă܂B";
		LogWithDate( strErrStr );
		delete strErrStr;
		return;
	}

	m_srtFileList->Add( nFileNum, strPath );
	
	
}



void nsSvcMHttp::LogP::Close( void )
{
	if ( m_strLogFileName != nullptr )
		delete m_strLogFileName;
	m_strLogFileName = nullptr;

	if ( m_fsLog ) {
		m_fsLog->Close();
		delete m_fsLog;
	}
	m_fsLog = nullptr;
}

void nsSvcMHttp::LogP::CloseOF( int nFileNum )
{
	if ( m_srtFileList->ContainsKey( nFileNum ) ) {
		m_srtFileList->Remove( nFileNum );
	}
}




void nsSvcMHttp::LogP::Log( String ^strData )
{
	/*******************************************************/
	/*************   rbNJn    *********************/
	System::Threading::Monitor::Enter( m_objLock );

	if ( m_blAutoFileNameChange_Date == true ) {
		
		String		^strCurDayFileName
			= MakeFileName();

		if ( strCurDayFileName != m_strLogFileName ) {
			delete m_strLogFileName;
			m_strLogFileName = gcnew String( strCurDayFileName );
		}
		delete strCurDayFileName;

	}
	


	try {
		m_fsLog = System::IO::File::Open( m_strLogFileName, System::IO::FileMode::Append, System::IO::FileAccess::Write, System::IO::FileShare::Read );
	} catch ( Exception ^e ) {
		delete e;
		m_fsLog->Close();
		delete m_fsLog;
		m_fsLog = nullptr;
		
		goto nsSvcMHttp_LogP_Log_EXIT;
	}


	

	m_fsLog->Seek( 0, System::IO::SeekOrigin::End );

	strData = String::Concat( strData, "\r\n" );
	array<Byte>		^byarData = System::Text::Encoding::GetEncoding( "SJIS" )->GetBytes( strData );
	m_fsLog->Write( byarData, 0, byarData->Length );
	delete byarData;


	m_fsLog->Close();
	delete m_fsLog;
	m_fsLog = nullptr;
	
nsSvcMHttp_LogP_Log_EXIT:
	System::Threading::Monitor::Exit( m_objLock );
	/*************   rbNI    *********************/
	/*******************************************************/


	

	return;
}


/* ftHgȊÕt@Cɏ */
void nsSvcMHttp::LogP::LogOF( int nFileNameNum, String ^strData )		// Log other file
{

	/*******************************************************/
	/*************   rbNJn    *********************/
	System::Threading::Monitor::Enter( m_objLock );

	if ( m_srtFileList == nullptr )
		goto nsSvcMHttp_LogP_LogOF_EXIT;
	if ( m_srtFileList->ContainsKey( nFileNameNum ) == false ) {
		goto nsSvcMHttp_LogP_LogOF_EXIT;
	}



	bool		blUpdateOrig;
	String		^strFileNameOrig;

	blUpdateOrig = m_blAutoFileNameChange_Date;
	m_blAutoFileNameChange_Date = false;


	strFileNameOrig = m_strLogFileName;
	m_strLogFileName = static_cast<String^>
		( m_srtFileList[ nFileNameNum ] );
	Log( strData );


	m_blAutoFileNameChange_Date = blUpdateOrig;
	m_strLogFileName = strFileNameOrig;

	delete strFileNameOrig;


nsSvcMHttp_LogP_LogOF_EXIT:
	System::Threading::Monitor::Exit( m_objLock );
	/*************   rbNI    *********************/
	/*******************************************************/

}




void nsSvcMHttp::LogP::LogWithDate( String ^strData )
{
	String ^strTime = GetFileNameDateStr();
	strTime = String::Concat( strTime, " ", strData );
	this->Log( strTime );
	delete strTime;
}

void nsSvcMHttp::LogP::LogOFWithDate( int nFileNum, String ^strData )
{
	String ^strTime = GetFileNameDateStr();
	strTime = String::Concat( strTime, " ", strData );
	this->LogOF( nFileNum, strTime );
	delete strTime;
}





String ^nsSvcMHttp::LogP::GetFileNameDateStr( void )
{
	int			nBuf;
	String		^strBuf = nullptr;
	String		^strTime = gcnew String( "" );

	/* hh:mm:ss Of[^ */
	nBuf = System::DateTime::Now.Hour;
	strBuf = System::Convert::ToString( nBuf );
	if ( strBuf->Length < 2 )
		strBuf = String::Concat( "0", strBuf );
	strTime = gcnew String( strBuf );
	delete strBuf;


	nBuf = System::DateTime::Now.Minute;
	strBuf = System::Convert::ToString( nBuf );
	if ( strBuf->Length < 2 )
		strBuf = String::Concat( "0", strBuf );
	strTime = String::Concat( strTime, ":", strBuf );
	delete strBuf;


	nBuf = System::DateTime::Now.Second;
	strBuf = System::Convert::ToString( nBuf );
	if ( strBuf->Length < 2 )
		strBuf = String::Concat( "0", strBuf );
	strTime = String::Concat( strTime, ":", strBuf );
	delete strBuf;



	return strTime;
}




String^ nsSvcMHttp::LogP::GetCurrentLogFileName( void )
{
	return m_strLogFileName;
}





String^ nsSvcMHttp::LogP::MakeFileName( void ) {

	System::Reflection::Assembly	^myAssembly
		= System::Reflection::Assembly::GetEntryAssembly();
	String	^strPath = myAssembly->Location;

	int		nPassDemiEnd = strPath->LastIndexOf( "\\" );
	/* nPassDemiEnd < 0 ͗L蓾ȂG[ */

	strPath = strPath->Substring( 0, nPassDemiEnd+1 );


	int				nBuf = System::DateTime::Now.Year;

	nBuf %= 100;
	String			^strDate;

	String ^strBuf = System::Convert::ToString( nBuf );
	if ( strBuf->Length < 2 )
		strBuf = String::Concat( "0", strBuf );
	strDate = gcnew String( strBuf );
	delete strBuf;


	nBuf = System::DateTime::Now.Month;
	strBuf = System::Convert::ToString( nBuf );
	if ( strBuf->Length < 2 )
		strBuf = String::Concat( "0", strBuf );
	strDate = String::Concat( strDate, strBuf );
	delete strBuf;


	nBuf = System::DateTime::Now.Day;
	strBuf = System::Convert::ToString( nBuf );
	if ( strBuf->Length < 2 )
		strBuf = String::Concat( "0", strBuf );
	strDate = String::Concat( strDate, strBuf );
	delete strBuf;




	strPath = String::Concat( strPath, "log", strDate, ".txt" );

	return strPath;
}

