
#include "stdafx.h"
#include "RecKanji.h"



using namespace System;



nsSvcMHttp::RecogKanji::RecogKanji()
{
	m_intUNKOWN = -1;

	m_intJIS   = 0;
	m_intSJIS  = 1;
	m_intEUC   = 2;
	m_intUTF8  = 3;
}
nsSvcMHttp::RecogKanji::~RecogKanji()
{
	;
}




int nsSvcMHttp::RecogKanji::ChkAllChars( array<Byte>  ^byarParseBuff )
{
	int		nRet = m_intUNKOWN;

	if ( IsJIS( byarParseBuff ) == true ) {
		return m_intJIS;
	}



	int nSjisCnt = 0;
	for( int nCnt = 0; nCnt < byarParseBuff->Length ; nCnt++ ) {

		if ( IsSJIS_single( byarParseBuff[ nCnt ] ) == true ) {
			nSjisCnt++;
			continue;
		}

		if ( IsSJIS_h( byarParseBuff[ nCnt ] ) == true ) {

			if ( nCnt+1 < byarParseBuff->Length ) {
				if ( IsSJIS_l( byarParseBuff[ nCnt+1 ] ) == true ) {
					nSjisCnt++;
					nCnt++;
					continue;
				}
			}
		}
	}



	int nEucCnt = 0;
	for( int nCnt = 0; nCnt < byarParseBuff->Length ; nCnt++ ) {

		int nRet = IsEUC( byarParseBuff, nCnt );
		if ( nRet < 0 )
			continue;

		nEucCnt++;
		nCnt += nRet - 1;
	}


	int nUtf8Cnt = 0;
	nUtf8Cnt = IsUTF8( byarParseBuff );

	

	if ( nSjisCnt > nEucCnt && nSjisCnt> 0) {
		nRet = m_intSJIS;
		
		if ( nUtf8Cnt > nSjisCnt ) {
			nRet = m_intUTF8;
		}

	} else if ( nEucCnt > 0 ) {

		if ( nUtf8Cnt > nEucCnt ) {
			nRet = m_intUTF8;
		} else if ( nEucCnt < nUtf8Cnt ) {
			nRet = m_intEUC;
		}	

	} else {

		if ( nUtf8Cnt > 0 ) {
			nRet = m_intUTF8;
		} else {
			nRet = m_intUNKOWN;
		}


	}




	return nRet;
}


bool nsSvcMHttp::RecogKanji::IsJIS( array<Byte>	^byarParseBuff )
{
	bool blRet = false;
	/* "1b 24 40" Pł JIS ɂ */

	bool blFind = false;
	int nCnt = 0;
	for ( nCnt = 0 ; nCnt < byarParseBuff->Length ; nCnt++ ) {

		if ( byarParseBuff[ nCnt ] == 0x1b ) {
			nCnt++;
			blFind = true;
			break;
		}
	}
	if ( blFind == false )
		return blRet;

	blFind = false;
	for ( ; nCnt < byarParseBuff->Length ; nCnt++ ) {

		if ( byarParseBuff[ nCnt ] == 0x24 ) {
			nCnt++;
			blFind = true;
			break;
		}
	}
	if ( blFind == false )
		return blRet;


	blFind = false;
	for ( ; nCnt < byarParseBuff->Length ; nCnt++ ) {

		if ( byarParseBuff[ nCnt ] == 0x40 ) {
			nCnt++;
			blRet = true;
			break;
		}
	}


	return blRet;
}



bool nsSvcMHttp::RecogKanji::IsSJIS_single( Byte byData )
{

	if ( ( byData >= 0x00 && byData <= 0x1f )  || 
         ( byData == 0x7f                   )  || 
         ( byData >= 0x20 && byData <= 0x7e )  ||
         ( byData >= 0xa1 && byData <= 0xdf ) 
	   ) {
		return true;
	}

	return false;

}



bool nsSvcMHttp::RecogKanji::IsSJIS_h( Byte	byData )
{
	if ( ( byData >= 0x81 && byData <= 0x9f )  || 
         ( byData >= 0xe0  && byData <= 0xfc )  
		 ) {
		return true;
	}
	return false;
}


bool nsSvcMHttp::RecogKanji::IsSJIS_l( Byte	byData )
{
	if ( ( byData >= 0x40 && byData <= 0x7e )  || 
         ( byData >= 0x80  && byData <= 0xfc )  
		 ) {
		return true;
	}
	return false;
}



int nsSvcMHttp::RecogKanji::IsEUC( array<Byte>  ^byarParse, int nSearch )
{
	int nRet = -1;

	if ( ( byarParse[ nSearch ] >= 0x00 && byarParse[ nSearch ] <= 0x1f )  || 
         ( byarParse[ nSearch ] == 0x7f                                 )  ||
         ( byarParse[ nSearch ] >= 0x20 && byarParse[ nSearch ] <= 0x7e )
       ) {
		nRet = 1;
		return nRet;
	}




	if ( byarParse[ nSearch ] >= 0xa1 && byarParse[ nSearch ] <= 0xfe ) {

		if ( nSearch + 1 < byarParse->Length ) {
			UInt16		ui16Buf;
			ui16Buf =   static_cast<UInt16>( byarParse[ nSearch     ] );
			ui16Buf <<= 8;
			ui16Buf |=  static_cast<UInt16>( byarParse[ nSearch + 1 ] );

			if ( ui16Buf >= 0x8ea1 && ui16Buf <= 0x8edf ) {
				nRet = 2;
				return nRet;
			}

		}
	}




	if ( byarParse[ nSearch ] == 0x8f ) {

		if ( nSearch + 2 < byarParse->Length ) {

			UInt32		ui32Buf;
			ui32Buf =   static_cast<UInt32>( byarParse[ nSearch     ] );
			ui32Buf <<= 8;
			ui32Buf |=  static_cast<UInt32>( byarParse[ nSearch + 1 ] );
			ui32Buf <<= 8;
			ui32Buf |=  static_cast<UInt32>( byarParse[ nSearch + 2 ] );

			if ( ui32Buf >= 0x8fa1a1 && ui32Buf <= 0x8ffefe ) {

				nRet = 3;
				return nRet;

			}

		}
	}


	return nRet;

}






int nsSvcMHttp::RecogKanji::IsUTF8( array<Byte>  ^byarParse )
{
	bool blUTF8 = true;
	int  nRet = 0;

	for( int nCnt = 0; nCnt < byarParse->Length; nCnt++ ) {

		Byte byBuf = byarParse[ nCnt ];

		if ( (byBuf & 0x80) == 0x00 ) {
			nRet++;
			continue;
		}

		int nExtCnt = 0;
		if (         ( byBuf & 0xe0 ) == 0xc0 ) {
			nRet += 2;
			nExtCnt = 1;
		} else if (  ( byBuf & 0xf0 ) == 0xe0 ) {
			nRet += 3;
			nExtCnt = 2;
		} else if (  ( byBuf & 0xf8 ) == 0xf0 ) {
			nRet += 4;
			nExtCnt = 3;
		} else if (  ( byBuf & 0xfc ) == 0xf8 ) {
			nRet += 5;
			nExtCnt = 4;
		} else if (  ( byBuf & 0xfe ) == 0xfc ) {
			nRet += 6;
			nExtCnt = 5;
		} else {
			blUTF8 = false;
			break;
		}

		while ( nExtCnt > 0 ) {
			if ( nCnt + 1 >= byarParse->Length ) {
				blUTF8 = false;
				break;
			}

			if ( (byarParse[ nCnt+1 ] & 0xc0) != 0x80 ) {
				blUTF8 = false;
				break;
			}
			nCnt++;
			nExtCnt--;

		}


		if ( blUTF8==false ){
			break;
		}

	}

	if ( !blUTF8 )
		nRet = -1;


	return nRet;
}

